//********************************************************************************************
/**
 * @file		boost.cpp
 * @brief		boost֘A\[X
 *
 *	̃\[XLɂꍇ main.h  #define	USE_BOOST LɂȂĂKv܂
 *
 * @author		N.Takeda
 * @date		2010/03/24() 10:57:47
 */
//********************************************************************************************

#include "main.h"

#include <string.h>
#include <stdlib.h>		// for mbstowcs(), wcstombs()
#include <locale.h>		// for setlocale()


#define	STRINGS_MAX			256			//	ϊA̍ő啶

struct	REP_LIST
{
	TCHAR	di[ STRINGS_MAX ];
	TCHAR	si[ STRINGS_MAX ];
};


#ifdef	USE_BOOST

#include <iostream>
#include <strstream>    // CN[hĂB
#include <string>
#include <boost/regex.hpp>

using namespace std;

//********************************************************************************************
/**
 * @brief		K\u(boostgp)
 * @author		N.Takeda
 * @date		2010/09/01() 16:03:08
 *
 * @param[in,out]	LPTSTR		_pOut	
 * @param[in,out]	REP_LIST*	_pRep	
 * @param[in]		int			_iEntry	
 *
 * @return		int	
 */
//********************************************************************************************
int		regex( LPTSTR _pOut, REP_LIST *_pRep, int _iEntry )
{
	xstring			str1;
	xstring			str2;
//	boost::smatch	mm;
	int				ii, iLen;
	
	
	for(ii=0 ; ii<_iEntry ; ii++)
	{
		boost::regex	r( _pRep[ii].si );
		
	//	str2 = (char*)CUnicodeF::sjis_to_utf16be((char*)_pOut, &iLen);
		str2 = _pOut;
		str1 = boost::regex_replace(str2, r, _pRep[ii].di, boost::format_all );
		iLen = str1.length();
	/*	
		std::strstream	cStrStrm( _pOut, iLen, std::ios::_pOut );		// zւ̃|C^,߂͈,ݐp
	    cStrStrm << str1 << std::ends;
	*/	
	}
	
	return iLen;
}

#else
/**
 * Boost .
 */

int		regex( LPTSTR _pOut, REP_LIST *_pRep, int _iEntry ){return -1;}

#endif

