//********************************************************************************************
/**
 * @file		main.cpp
 * @brief		v
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2010/03/24() 19:41:55
 */
//********************************************************************************************
#include "main.h"
#include "params.h"

#include <commctrl.h>
#include <mbstring.h>

#include <assert.h>
#ifndef _STOOLS_H
#include <system/win32/env.h>
#endif
#include "resource.h"

#include "string/csv.h"



#ifdef _DEBUG
//# define	DEBUG_OUT_BATCMD						///< Lɂƃob`t@C擾R}hbatcmd.txtɏo.
//# define BATCH_TEST								///< LɂƎw肵ob`t@CNɌŒǂݍ.
#endif


#ifdef BATCH_TEST
// Œob`.
//char	*s_lpszCmdLine = "\"D:\\work\\program\\tool\\swComponent\\_update.swb\"";	///< tpXŎw肷.
//char	*s_lpszCmdLine = "\"C:\\work\\tool\\swriter\\sample\\checkExcel\\checkExcel.swb\"";	///< tpXŎw肷.
char	*s_lpszCmdLine = "-s\\\"C:\\tool\\cpp2htm\\cpp2htm %1 /mode:\"section\" /dlg:0\\\" -f*.txt -oOUTINFONAME=C:\\work\\tool\\swriter\\swriter\\OutputcheckTxt.txt";
#endif

/**
	`
 */
#define	MESSAGEINFO_SIZE	(1024*1024)	///< bZ[WEBhEobt@TCY(I[o[Ƃ̃TCYXɉZ).
#define	MESSAGE_1MAX		(256*1024)	///< xɃbZ[W\ł钷.

#define	DROP_BATCHLINE		(60)

static	const	TCHAR	c_sButton[]			= TEXT("BUTTON");
static	const	TCHAR	c_sStatic[]			= TEXT("STATIC");
static	const	TCHAR	c_sEdit[]			= TEXT("EDIT");
static	const	TCHAR	c_sListBox[]		= TEXT("LISTBOX");


static	const	TCHAR	c_sSettingSectionMain[]	= TEXT("SETTING");
static	const	TCHAR	c_sIniSectionMain[]	= TEXT("MAIN");

static	const	TCHAR	c_sDefaultOutFile[]	= TEXT("MSG.TXT");	///< ftHg̃bZ[Wo̓t@C.


static	const	TCHAR	c_sTempSwbName[]	= TEXT("temp.swb");	///< 
TCHAR	c_sTempSwbPath[ T_MAXPATH ] = TEXT("");


/// AvP[V[J̕ϐ
WINDOW_INFO		s_cWin;
STRUCT_GLOBAL	s_stGl;


static	Int32	s_iMIsize;
static	Int32	WINDOW_W;							///< EBhE.
static	Int32	WINDOW_H;							///< EBhEc.


void	swriter_cmd( SCRIPT_STAT SStat, LPCTSTR pPath );
void	swriter_exit( Bool bExit );


Bool	Read_SWriterBatch( LPCTSTR _pFName );

static	Bool	OpenGetFileName( HWND hWnd );
static	void	default_function();
static	void	set_messagepath( LPTSTR path );


//------------------------------------------------------
//		Windowsb֐
//------------------------------------------------------
static Bool Init_Window( HINSTANCE _hInstance, HINSTANCE _hPrevInstance, LPSTR _lpszCmdLine, Int32 _cmdShow );
static void Init_MainWnd();
static void Init_ChildWnd_zero();
static void Init_ChildWnd();
static void Init_SystemMenu();
static long FAR PASCAL MainWndProc( HWND hWnd, UINT message, UINT wParam, LONG lParam );

//------------------------------------------------------
//		WindowsMessage
//------------------------------------------------------
static void MyWmCreate( HWND hWnd );
static void MyWmClose( HWND hWnd );
static void MyWmPaint( HWND hWnd );
static void MyWmDropFiles( HWND hWnd, HDROP hDrop );
static void MyWmCommand( HWND hWnd, WPARAM wParam, LPARAM lParam );

//------------------------------------------------------
//		Timer֘A
//------------------------------------------------------
static void TimerStart_conv( HWND hWnd );
static void CALLBACK TimerFunc_conv( UINT wID, UINT wUser, DWORD dwUser, DWORD dw1, DWORD dw2 );

//static void CALLBACK TimerFunc_wave( UINT wID, UINT wUser, DWORD dwUser, DWORD dw1, DWORD dw2 );

static void TimerStop( HWND hWnd, UINT &id);



//------------------------------------------------------
//		֐
//------------------------------------------------------
void	List_show();
void 	line_list( Int32 idx );
static void List_del();
static void List_delext1();
static void List_delext2();
static void Data_Initialize();
static void CmdLine_Parameter( LPTSTR cmdLien, LPTSTR data );

static void read_profile();
void	write_profile();

static	void	GetCommandParam( SCRIPT_STAT *pSStat, xstring sString );

static	void	Push_start( Bool bEffStop );

static	Bool	TimerConv( HWND hWnd );
static	void	out_infomessage( LPTSTR name );

static	Bool	MakeTempScript( LPCTSTR _pCmdLine );


//------------------------------------------------------
//		O֐
//------------------------------------------------------
Bool 	Dlg_msgbox1();
Bool 	Dlg_msgbox3();
Bool 	Dlg_msgbox6();



////////////////////////////////////////////////////////////////
//      ꂪCvOł                            //
////////////////////////////////////////////////////////////////
Int32 PASCAL WinMain( HINSTANCE _hInstance, HINSTANCE _hPrevInstance, LPSTR lpszCmdLine, Int32 _cmdShow )
{
	MSG	  msg;
	
	
#if 0
	TCHAR		sStr[ 256 ] = TEXT("D:\\work\\program\\tool\\swriter\\swriter\\checktxt\\readme.txt \"\\123456\\\"  ABCDWEEF	\"kakko no naka\" ");
	CSwbParam	cObj( sStr );
	
	cObj.Trace();
	TRACE( TEXT("*1:%s\n"), cObj.GetFilePath( 1 ) );
#endif
	
	
	if( Init_Window( _hInstance, _hPrevInstance, lpszCmdLine, _cmdShow ) )
	{
		while( GetMessage( &msg, NULL, 0, 0 ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		
		return msg.wParam;
	}
	
	WINDOW_Destroy( s_cWin );
#ifdef _DEBUG
#else	// _DEBUG
	FILE_delete( c_sTempSwbPath );
#endif	// not _DEBUG
	
	return 0;
}


//////////////////////////////////////////////////////////
//		EBhECjVCY						//
//////////////////////////////////////////////////////////
static Bool Init_Window( HINSTANCE _hInstance, HINSTANCE _hPrevInstance, LPSTR _lpszCmdLine, Int32 _cmdShow )
{
	TCHAR	sTemp[_MAX_PATH], drive[_MAX_DRIVE], cDir[_MAX_DIR];
	
	
	s_stGl.ScriptPath[0] = 0;
	s_stGl.MessagePath[0] = 0;
	
#ifdef BATCH_TEST
	_lpszCmdLine = reinterpret_cast<LPSTR>(s_lpszCmdLine);
#endif
	
	if( !_hPrevInstance )
	{
		s_stGl.hInst = _hInstance;
		
		/// ƃfBNgm.
		GetModuleFileName( s_stGl.hInst, sTemp, sizeof(sTemp) );
		FILE_split( sTemp, drive, cDir, NULL, NULL );
		FILE_merge( s_stGl.MainPath, drive, cDir, NULL, NULL );
		
		read_profile();
		Data_Initialize();	///< f[^̏.
		
		{
#ifdef	_UNICODE
			CTOUTF16	cUtf;
			CmdLine_Parameter( cUtf.From(_lpszCmdLine), sTemp );	///< R}hC̈擾.
#else
			CmdLine_Parameter( _lpszCmdLine, sTemp );				///< R}hC̈擾.
#endif
		}
		
		Bool	bNormalExec = FALSE;
		if( MakeTempScript( sTemp ) == FALSE )						///< ɒXNvgw肵ĂȂ`FbN.
		{
			if( sTemp[ 1 ] == ':' )
			{
				/// tpX͂̂܂.
				STRING_cpy( s_stGl.ScriptPath, sTemp );
			}
			else{
				/// tpXłȂȂJgt.
				FILE_GetCurrentDirectory( s_stGl.ScriptPath );
				catyen( s_stGl.ScriptPath );
				STRING_cat( s_stGl.ScriptPath, sTemp );
			}
			bNormalExec = TRUE;
		}
		
		Init_MainWnd();
		
		if( s_stGl.ScriptPath[0] != 0 )		///< w肳Ă̂̓ob`N.
		{
			if( FALSE == Read_SWriterBatch( s_stGl.ScriptPath ) )
			{
				/// Ɏw肵Ăt@CȂ.
				Message_error( TEXT("not found. %s"), s_stGl.ScriptPath );
			}
			set_messagepath( s_stGl.ScriptPath );
			if( s_stGl.m_pOption->m_bAuto && s_stGl.m_cXcopy.GetEntry() > 0 ){	///< NonŃt@Cw肳ĂȂ.
				s_stGl.autoexec = 1;											///< N(ĕ`Ŏ󂯎sĂ).
			}else
				s_stGl.autoexec = 0;
			
		}
		
		if( bNormalExec && !s_stGl.m_pOption->m_bDefaultCurrent )	///< IvV̓ob`[hłȂƓĂȂ̂łōs.
		{
			/// XNvgi[ĂtH_Jg.
			FILE_split( s_stGl.ScriptPath, drive, cDir, NULL, NULL );
			FILE_merge( sTemp, drive, cDir, NULL, NULL );
			FILE_SetCurrentDirectory( sTemp );								///< Jgړ(ob`hbvAEgN̎̓JgC:\̂).
		}
		
		default_function();
		
		Init_ChildWnd();
		
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////
//      CEBhE쐬                          //
////////////////////////////////////////////////////////
static void Init_MainWnd()
{
	s_cWin = WINDOW_SetStdInfo( TEXT("PROC"), WINDOW_TITLE, enWindowTypeStandard, MainWndProc, s_stGl.hInst, WINDOW_W, WINDOW_H );
	
	WINDOW_SetMenu( s_cWin, (TCHAR*)IDR_MENU1 );
	WINDOW_Create( s_cWin );
	
	WINDOW_Update( s_cWin, SW_SHOW );
	
	// t@Chbv/s
	DragAcceptFiles( s_cWin.m_hWnd, TRUE );
	
	// ^Cgo[̃ACR
	SetClassLong( s_cWin.m_hWnd, GCL_HICON, (long)LoadIcon( s_stGl.hInst, (LPTSTR)IDI_ICON1 ) );
	
	Init_ChildWnd_zero();
	Init_SystemMenu();
	
	s_stGl.TimerID = 0;
}


////////////////////////////////////////////////////////
//      qEBhE̍쐬                            //
////////////////////////////////////////////////////////
static void Init_ChildWnd()
{
	HWND			hTmp;
	TCHAR			cStr[ 32 ];
	
	
	s_stGl.hStart = CreateWindow( c_sButton, TEXT("Jn"),
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		WINDOW_W-90, 5, 80, 20,
		s_cWin.m_hWnd, (HMENU)BTN_START, s_stGl.hInst, NULL );
	SendMessage( s_stGl.hStart, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	
	
	hTmp = CreateWindow( c_sStatic, TEXT("SWriteBatch"),
		WS_CHILD | WS_VISIBLE,
		10,8,75,15,
		s_cWin.m_hWnd, NULL, s_stGl.hInst, NULL );
	SendMessage( hTmp, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	
	s_stGl.hScriptPath = CreateWindowEx( WS_EX_CLIENTEDGE, c_sEdit, s_stGl.ScriptPath,
		WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL,
		90, 5, WINDOW_W-190, 18,
		s_cWin.m_hWnd, NULL, s_stGl. hInst, NULL );
	SendMessage( s_stGl.hScriptPath,WM_SETFONT,(WPARAM)s_stGl.hFont,MAKELPARAM(FALSE,0) );
	
	
	//	t@CXg
	hTmp = CreateWindow( c_sStatic, TEXT("File list"),
		WS_CHILD | WS_VISIBLE,
		10, 32, 60, 12,
		s_cWin.m_hWnd, NULL, s_stGl.hInst, NULL );
	SendMessage( hTmp, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	
	s_stGl.hFlist = CreateWindowEx( WS_EX_CLIENTEDGE, c_sListBox, TEXT(""),
		WS_CHILD | WS_VSCROLL | WS_VISIBLE | LBS_HASSTRINGS | LBS_DISABLENOSCROLL | LBS_NOTIFY,
		10, 46, 160, WINDOW_H-46-17,
		s_cWin.m_hWnd, NULL, s_stGl.hInst, NULL );
	SendMessage( s_stGl.hFlist, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	
	List_show();	// mۂꂽf[^Xg{bNXɕ\
	
	if(s_stGl.bFuntion_lock)
		EnableWindow( s_stGl.hScriptPath, FALSE );
	
	wsprintf( cStr, TEXT("Entry : %3d"), s_stGl.m_cXcopy.GetEntry() );
	s_stGl.hEntry = CreateWindow( c_sStatic, cStr,
		WS_CHILD | WS_VISIBLE,
		10, WINDOW_H-17, 80, 12,
		s_cWin.m_hWnd, NULL, s_stGl.hInst, NULL );
	SendMessage( s_stGl.hEntry, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	
}


////////////////////////////////////////////////////////
//      qEBhE̍쐬                            //
//		ÑG[󂯎邽ߐɏ		  //
////////////////////////////////////////////////////////
static void Init_ChildWnd_zero()
{
	HWND		hTmp;
	
	s_stGl.hFont = CreateFont( 12, 0, 0, 0, FW_EXTRALIGHT, FALSE, FALSE, 0, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, TEXT("lr SVbN") );
	
	
	//	CtH[V
	hTmp = CreateWindow( c_sStatic, TEXT("Message"), WS_CHILD | WS_VISIBLE,
		175,32,76,12,s_cWin.m_hWnd,NULL,s_stGl.hInst,NULL );
	SendMessage( hTmp, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	
	s_stGl.hInfo = CreateWindowEx( WS_EX_CLIENTEDGE, c_sEdit, TEXT(""),
		WS_CHILD | WS_VSCROLL | WS_VISIBLE | ES_MULTILINE | ES_AUTOVSCROLL,
		175, 46, WINDOW_W-180, WINDOW_H-56, s_cWin.m_hWnd, NULL, s_stGl.hInst, NULL );
	SendMessage( s_stGl.hInfo, WM_SETFONT, (WPARAM)s_stGl.hFont, MAKELPARAM(FALSE,0) );
	SendMessage( s_stGl.hInfo, EM_SETREADONLY, (WPARAM)(Bool)TRUE, 0 );
	
	s_iMIsize = MESSAGEINFO_SIZE;
	mem_alloc( TCHAR, s_stGl.m_memMsg, s_iMIsize );
	
}


////////////////////////////////////////////////////////
//      VXej[ݒ                          //
////////////////////////////////////////////////////////
static void Init_SystemMenu()
{
	HMENU	hMenu;
	
	hMenu = GetSystemMenu( s_cWin.m_hWnd, FALSE );
	
}


////////////////////////////////////////////////////////////////
//      C[`ɂ悤I                          //
////////////////////////////////////////////////////////////////
static long FAR PASCAL MainWndProc( HWND hWnd,UINT message,UINT wParam,LONG lParam )
{
	switch( message )
	{
		/// ^C}[Ń|Xg(IWi)
		case TIMER_LOOP_CONV:
			if( TimerConv( hWnd ) == FALSE ){
				TimerStop( hWnd,s_stGl.TimerID );
				
				if(s_stGl.autoexec == 2 && s_stGl.m_pOption->m_bAtExit && s_stGl.iErrors==0)	///< NĂāAIonŃG[ȂȂI
					PostMessage( hWnd, WM_CLOSE, 0, 0 );
			}
			s_stGl.TimerFlag = FALSE;
			break;
		
		/// EBhE쐬(\O)
		case WM_CREATE:
			MyWmCreate( hWnd );
			break;
		
		/// EBhEĕ`掞
		case WM_PAINT:
			MyWmPaint( hWnd );
			break;
		
		/// WindowsI
		case WM_QUERYENDSESSION:
			MyWmClose( hWnd );
			return 1L;
		
		/// AvP[VI
		case WM_CLOSE:
			DestroyWindow( hWnd );
#ifdef _DEBUG
#else	// _DEBUG
			FILE_delete( c_sTempSwbPath );
#endif	// not _DEBUG
			break;
		
		/// EBhE̔j
		case WM_DESTROY:
			MyWmClose( hWnd );
			PostQuitMessage( 0 );
			break;
		
		/// t@Chbvꂽ
		case WM_DROPFILES:
			MyWmDropFiles( hWnd, (HDROP)wParam );
			break;
		
		case WM_SIZE:
			switch(wParam){			///< TCYύX̎ނtO.
				case SIZE_MAXIMIZED:	///< EBhEő剻܂
				case SIZE_MINIMIZED:	///< EBhEACR܂
				case SIZE_MAXHIDE:		///< ق̃EBhEő剻ꂽƂɁAbZ[WׂẴ|bvAbv EBhEɑ܂
				case SIZE_MAXSHOW:		///< ق̃EBhEꂽƂɁAbZ[WׂẴ|bvAbv EBhEɑ܂
					break;
				case SIZE_RESTORED:		///< EBhẼTCY (ő剻܂̓ACRȊÕTCY) ύX܂
					
					/// {^ނ̍Ĕzu
					MoveWindow( s_stGl.hInfo, 175, 46, LOWORD(lParam)-180, HIWORD(lParam)-56, TRUE );
					MoveWindow( s_stGl.hFlist, 10, 46, 160, HIWORD(lParam)-46-17, TRUE );
					MoveWindow( s_stGl.hEntry, 10, HIWORD(lParam)-17, 80, 12, TRUE );
					
					MoveWindow( s_stGl.hStart, LOWORD(lParam)-90, 5, 80, 20, TRUE );
					MoveWindow( s_stGl.hScriptPath, 90, 5, LOWORD(lParam)-190, 18, TRUE );
					
					/// TCYXV
					WINDOW_W = LOWORD(lParam);
					WINDOW_H = HIWORD(lParam);
			}
			break;
		
		/// ---- L[ꂽ
		case WM_KEYDOWN:
			switch(wParam){
				case VK_RETURN:
					if( s_stGl.m_pOption->m_bRetexec )	Push_start( TRUE );
					break;
			}
			break;
		
		/// R}h͂ꂽ
		case WM_COMMAND:
			MyWmCommand( hWnd, wParam, lParam );
			break;
		
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
	}
	
	return 0L;
}


//======================================================
//		EBhE쐬
//======================================================
static void MyWmCreate( HWND hWnd )
{
	
}


//======================================================
//		EBhE
//======================================================
static void MyWmClose( HWND hWnd )
{
	mem_del(s_stGl.m_memMsg);
	
	DeleteObject( s_stGl.hFont );
	
	write_profile();
	
}


//======================================================
//		EBhEĕ`掞
//======================================================
static void MyWmPaint( HWND hWnd )
{
	PAINTSTRUCT		ps;
	
	if(s_stGl.autoexec == 1){		///< `ANݒ肳Ăs
		Push_start( TRUE );
		s_stGl.autoexec = 2;		///< N
	}
	
	/// 󏈗łuĂȂƎqEBhE`悪Ȃ
	BeginPaint( hWnd, ( LPPAINTSTRUCT )&ps );
	
	EndPaint( hWnd, ( LPPAINTSTRUCT )&ps );
	
//	ValidateRect( hWnd, NULL );
	
}


//======================================================
//		t@ChbOꂽ
//======================================================
static void MyWmDropFiles( HWND _hWnd, HDROP _hDrop )
{
	TCHAR		cDrive[_MAX_DRIVE], cDir[_MAX_DIR];
	TCHAR		szName[_MAX_PATH], cWork[_MAX_PATH];
	POINT		pt;
	Int32			iEntry, ii;
	
	
	/// t@Chbvꂽʒu擾
	if( DragQueryPoint( _hDrop, &pt ) == FALSE )	return;
	
	if( pt.y < DROP_BATCHLINE )
	{
		/// ob`t@C̈Ƀhbv
		DragQueryFile( _hDrop, 0, s_stGl.ScriptPath, sizeof(s_stGl.ScriptPath) );
		
		/// JgfBNghbvt@C̃pXړ
		FILE_split( s_stGl.ScriptPath, cDrive, cDir, NULL, NULL );
		FILE_merge( cWork, cDrive, cDir, NULL, NULL );
		FILE_SetCurrentDirectory( cWork );
		
		if( !s_stGl.bFuntion_lock )
			SetWindowText( s_stGl.hScriptPath, s_stGl.ScriptPath );
		
		Data_Initialize();
		
		Read_SWriterBatch( s_stGl.ScriptPath );
		List_show();
		return;
	}
	
	/// hbvꂽt@C
	iEntry = DragQueryFile( _hDrop, 0xFFFFFFFF, NULL, 0 );
	
	s_stGl.m_cXcopy.SetSearchSubDir( s_stGl.m_pOption->m_bSearchSubDir );	///< ob`D. VXeɂ悢.
	
	for( ii=0 ; ii<iEntry ; ii++ )
	{
		DragQueryFile( _hDrop, ii, szName, sizeof(szName) );
		s_stGl.m_cXcopy.AddXcopy( szName );
	}
	
	List_show();	///< Xg\.
	
	DragFinish( _hDrop );
	
}


//======================================================
//		R}h
//======================================================
static void MyWmCommand( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	SCRIPT_STAT		SStat;
	TCHAR			cTemp[ 256 ];
	
	
	#define	COM_ONETOUCH(id,Command,Param)	case id:if(s_stGl.bLock)break;\
											if(s_stGl.bFuntion_lock){	_message(TEXT("^b`@\͗pł܂"));return;}\
											SStat.sCommand = Command;SStat.sParam = Param;STRING_cpy(s_stGl.ScriptPath,Command);\
											goto	skip
	
	//									STRING_cpy(temp,string);STRING_cpy(s_stGl.ScriptPath,temp);
	
	switch( LOWORD(wParam) ){
	/// -----j[-----.
	/// t@C.
		//
		case ID_MENU_BATLOAD:
			if(s_stGl.bLock)break;
			OpenGetFileName( hWnd );
			List_show();
			break;
		//Infomationo
		case ID_MENU_OUTINFO:
			if(s_stGl.bLock)break;
			out_infomessage( s_stGl.m_cSysOption.m_sOutInfoName );
			break;
		//vpeB
		case ID_MENU_PROPERTY:
			if(s_stGl.bLock)break;
			Dlg_msgbox1();
			break;
		//I
		case ID_MENU_EXIT:
			if(s_stGl.bLock)break;
			PostMessage( hWnd,WM_CLOSE,0,0 );
			break;
		
	/// ҏW.
		/// SNA.
		case ID_MENU_CLEAR:
			if(s_stGl.bLock)break;
			List_clear();
			Message_clear();
			break;
		case ID_MENU_LISTDEL:
			if(s_stGl.bLock)break;
			List_del();
			break;
		case ID_MENU_NOTEXTDEL:
			List_delext1();
			break;
		case ID_MENU_EXTDEL:
			List_delext2();
			break;
	/*	case ID_MENU_LISTUP:
			List_up();
			break;
		case ID_MENU_LISTDOWN:
			List_down();
			break;
	*/	
		
	/// ^b`@\	MENUID				R}h			p[^.
		COM_ONETOUCH( ID_MENU_OP_DELREM,		TEXT("DELREM"),		TEXT(""));		///< ߍ폜.
		COM_ONETOUCH( ID_MENU_OP_KANJICHK,		TEXT("KANJI_CHECK"),TEXT("1"));		///< `FbN.
		COM_ONETOUCH( ID_MENU_OP_ZEN2HAN,		TEXT("ZEN2HAN"),	TEXT(""));		///< pϊ.
		COM_ONETOUCH( ID_MENU_OP_LISTSORT,		TEXT("LISTSORT"),	TEXT("-op"));	///< \[g.
		COM_ONETOUCH( ID_MENU_OP_FILECHECK,		TEXT("FILECHECK"),	TEXT(""));		///< t@C`FbN.
		COM_ONETOUCH( ID_MENU_OP_BINARYDUMP,	TEXT("DUMP"),		TEXT(""));		///< _u.
		COM_ONETOUCH( ID_MENU_OP_SAMESIZE,		TEXT("SAMESIZE"),	TEXT(""));		///< TCY.
		
		skip://Sʕ
			s_stGl.m_stScrStat.clear();
			s_stGl.m_stScrStat.push_back( SStat );
			
			wsprintf( cTemp, TEXT("%s %s"), SStat.sCommand.c_str(), SStat.sParam.c_str() );
			SetWindowText( s_stGl.hScriptPath, cTemp );
			STRING_cpy( s_stGl.ScriptPath, cTemp );
			
			if(s_stGl.m_cXcopy.GetEntry() != 0 ){
				Push_start( TRUE );
			}
			break;
		
	/// wv.
		//About
		case ID_MENU_ABOUT:
			if( s_stGl.bLock )	break;
			Dlg_msgbox6();
			break;
		
	/// -----{^-----.
		/// Jn{^ꂽ.
		case BTN_START:
			
			GetWindowText( s_stGl.hScriptPath, s_stGl.ScriptPath , sizeof(s_stGl.ScriptPath) );
			
			Push_start( TRUE );
			break;
		
	}
	
}




////////////////////////////////////////////////////////////////////////////////
//		֐
////////////////////////////////////////////////////////////////////////////////



// -----֘At
//======================================================
//		R}hC̃p[^擾
//======================================================
static void CmdLine_Parameter( LPTSTR cmdLien, LPTSTR data )
{
	Int32		ii;
	
	if( cmdLien[0] == '"' ){
		for( ii = 0 ; cmdLien[ii+1] != '"' ; ii++ ){
			if( cmdLien[ii+1] == '\0' )	break;
			data[ii] = cmdLien[ii+1];
		}
		data[ii] = '\0';
	}
	else{
		STRING_cpy( data,cmdLien );
	}
}


// -----Xg{bNX
//======================================================
//		Xgf[^\
//======================================================
void	List_show()
{
	Int32		ii, iEntry;
	TCHAR	str[ 32 ];
	
	
	iEntry = s_stGl.m_cXcopy.GetEntry();
	
	if( iEntry == 0 )	return;
	
	for( ii = 0 ; ii < (Int32)iEntry ; ii++ )	line_list( ii );
	
	SendMessage( s_stGl.hFlist,LB_SETCURSEL,(WPARAM)0,0 );
	
	wsprintf( str, TEXT("Entry : %3d"), iEntry );
	SetWindowText( s_stGl.hEntry, str );
	
}




//======================================================
//		XgS
//======================================================
void	List_clear()
{
	SendMessage( s_stGl.hFlist,LB_RESETCONTENT,0,0 );
	s_stGl.m_cXcopy.Clear();
	
	SetWindowText( s_stGl.hEntry, TEXT("Entry :   0") );
	
	s_stGl.ScriptPath[0] = 0;
	SetWindowText( s_stGl.hScriptPath, s_stGl.ScriptPath );
	
}


void 	line_list( Int32 idx )
{
	TCHAR	cBuff[256];
	
	
	wsprintf( cBuff, TEXT("%-13s"), s_stGl.m_cXcopy.GetStringFileName(idx).c_str() );
	
	SendMessage( s_stGl.hFlist, LB_DELETESTRING, (WPARAM)idx, 0 );
	SendMessage( s_stGl.hFlist, LB_INSERTSTRING, (WPARAM)idx, (LPARAM)cBuff );
	SendMessage( s_stGl.hFlist, LB_SETCURSEL, (WPARAM)idx, 0 );
	
}


//======================================================
//		Xg폜
//======================================================
static void List_del()
{
	Int32		iIdx;
	TCHAR	str[32];
	
	
	if( s_stGl.m_cXcopy.GetEntry() == 0 )	return;
	
	iIdx = SendMessage( s_stGl.hFlist,LB_GETCURSEL,0,0 );
	if( iIdx == -1 )	return;
	
	SendMessage( s_stGl.hFlist,LB_DELETESTRING,(WPARAM)iIdx,0 );
	
	if( iIdx == s_stGl.m_cXcopy.GetEntry()-1 )
		SendMessage( s_stGl.hFlist,LB_SETCURSEL,(WPARAM)(iIdx-1),0 );
	else
		SendMessage( s_stGl.hFlist,LB_SETCURSEL,(WPARAM)iIdx,0 );
	
	s_stGl.m_cXcopy.Delete( iIdx );
	
	wsprintf( str,TEXT("Entry : %3d"),s_stGl.m_cXcopy.GetEntry() );
	
	SetWindowText( s_stGl.hEntry, str );
}


//======================================================
//		Xg폜	wgqȊO폜
//======================================================
static void List_delext1()
{
	Int32		iIdx;
	xstring		sExt;
	
	
	if( s_stGl.m_cXcopy.GetEntry() == 0 )	return;
	
	iIdx = SendMessage( s_stGl.hFlist,LB_GETCURSEL,0,0 );
	if( iIdx == -1 )	return;
	
	sExt = s_stGl.m_cXcopy.GetFileExt( iIdx );
	
	s_stGl.m_cXcopy.DeleteOnExt( sExt.c_str(), TRUE );
	
	SendMessage( s_stGl.hFlist,LB_RESETCONTENT,0,0 );
	List_show();
}


//======================================================
//		Xg폜	wgq폜
//======================================================
static void List_delext2()
{
	Int32		iIdx;
	xstring		sExt;
	
	
	if( s_stGl.m_cXcopy.GetEntry() == 0 )	return;
	
	iIdx = SendMessage( s_stGl.hFlist,LB_GETCURSEL,0,0 );
	if( iIdx == -1 )	return;
	
	sExt = s_stGl.m_cXcopy.GetFileExt( iIdx );
	
	s_stGl.m_cXcopy.DeleteOnExt( sExt.c_str(), FALSE );
	
	SendMessage( s_stGl.hFlist,LB_RESETCONTENT,0,0 );
	List_show();
}


//********************************************************************************************
/**
 * @brief		f[^̏
 *				XNvgAt@CXgAbZ[WNA
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
static void Data_Initialize()
{
	s_stGl.m_cXcopy.Clear();
	
	s_stGl.m_stScrStat.clear();
	
	if( s_stGl.m_memMsg != NULL )	s_stGl.m_memMsg[ 0 ] = 0;
	
	s_stGl.iErrors = 0;
}


// -----Jn
//======================================================
//		sJn
//======================================================
static void Push_start( Bool _bEffStop )
{
	
	if( _bEffStop == TRUE && s_stGl.bLock == TRUE )		///< sēx{^ꂽu~v
	{
		s_stGl.bFlagStop = TRUE;
		Message_win( TEXT("Stoped...") );
		
		SetWindowText( s_stGl.hStart, TEXT("Jn") );
		s_stGl.bLock = FALSE;
		
		if( s_stGl.m_pOption->m_bOutInfo )	out_infomessage( s_stGl.m_pOption->m_sOutInfoName );
		
		return;
	}
	
	
	if(s_stGl.m_cXcopy.GetEntry() == 0 ){
		_message( TEXT("t@CIĂ܂") );
		return;	//	t@CȂ
	}
	
	if( s_stGl.ScriptPath[0] == 0 )
	{
		GetWindowText( s_stGl.hScriptPath, s_stGl.ScriptPath , sizeof(s_stGl.ScriptPath) );
		
		if( s_stGl.ScriptPath[0] != 0 )
		{
			SCRIPT_STAT		SStat;
			xstring			sString = s_stGl.ScriptPath;
			
			GetCommandParam( &SStat, sString );
			s_stGl.m_stScrStat.push_back( SStat );
		}
		
	}
	
	if( s_stGl.ScriptPath[0] == 0 || s_stGl.m_stScrStat.empty() )
	{
		_message(TEXT("R}hw肳Ă܂"));
		return;	//	XNvgȂ
	}
	
	Message_clear();
	
	s_stGl.bLock = TRUE;
	SetWindowText( s_stGl.hStart, TEXT("~") );
	
	
	s_stGl.m_itStat = s_stGl.m_stScrStat.begin();
	
	s_stGl.m_iIdx = 0;
	s_stGl.bFlagStop = FALSE;
	s_stGl.err = 0;
	
/*	
	STRING_cpy(path,s_stGl.OutPath);
	if(path[0] != 0)
		if(path[STRING_len(path)-1] != '\\')	STRING_cat(path,"\\");
	STRING_cat(path,s_stGl.OutFile);
*/	
	s_stGl.m_cXcopy.SetSearchSubDir( s_stGl.m_pOption->m_bSearchSubDir );
	
	TimerStart_conv( s_cWin.m_hWnd );
	
}


//======================================================
//		^C}[
//======================================================
static Bool TimerConv( HWND hWnd )
{
	/// u~vɂI
	if( s_stGl.bFlagStop )	return FALSE;
	
	//	J[\킹
	line_list( s_stGl.m_iIdx );
	
	swriter_cmd( *s_stGl.m_itStat , s_stGl.m_cXcopy.GetPathFileName( s_stGl.m_iIdx ) );
	
	line_list( s_stGl.m_iIdx );	//	XgEBhEeXV
	
	s_stGl.m_iIdx++;
	if( s_stGl.m_iIdx >= (Int32)s_stGl.m_cXcopy.GetEntry() || s_stGl.err != 0 )
	{
		if(s_stGl.err == 0)
		{
			s_stGl.m_itStat++;
			
			if( s_stGl.m_itStat != s_stGl.m_stScrStat.end() )
			{
			//	̃XNvgR}hݒ肵Ďn߂
				s_stGl.m_iIdx = 0;
				
				//	I	ł܂̃XNvgꍇ
				swriter_exit( FALSE );
				return TRUE;
			}
		}
		
		//	I
		swriter_exit( TRUE );
		
		if(s_stGl.iErrors == 0)	Message_win( TEXT("Completed..."));
		else					Message_printf( TEXT("error(s).%d"), s_stGl.iErrors );
		
		if(s_stGl.m_pOption->m_bOutInfo)	out_infomessage( s_stGl.m_pOption->m_sOutInfoName );
		
		SetWindowText( s_stGl.hStart, TEXT("Jn") );
		s_stGl.bLock = FALSE;
		
		return FALSE;	//	I
	}
	
	return TRUE;
}


//********************************************************************************************
/**
 * @brief		ftHg̋@\
 *				@\肵ĂꍇAXNvgR}h .ini ǂݍ
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
static	void	default_function()
{
	TCHAR	defFile[ _MAX_PATH ], drive[ _MAX_DRIVE ], cDir[ _MAX_DIR ];
	
	
	if( s_stGl.bFuntion_lock == FALSE )
		if(s_stGl.ScriptPath[0] != 0)	return;		//Batch ɂNꍇBatchD(AFunction_LockĂȂꍇ)
	
	FILE_split( s_stGl.MainPath, drive, cDir, NULL, NULL );
	FILE_merge( defFile, drive, cDir, TEXT("swriter"), TEXT(".ini") );
	
	
	GetPrivateProfileString( TEXT("EXTRA"), TEXT("NAME"), TEXT(""), s_stGl.ScriptPath, _MAX_FNAME, defFile );
	
	if( s_stGl.ScriptPath[0] != 0 )
	{
		SCRIPT_STAT	SStat;
		TCHAR		temp[256];
		
		GetPrivateProfileString(TEXT("EXTRA"), TEXT("SCRIPT"), TEXT(""), temp, 256, defFile);
		SStat.sCommand = temp;
		SStat.sParam.clear();
		s_stGl.m_stScrStat.push_back( SStat );
	}
}


// -----ݒt@C
//********************************************************************************************
/**
 * @brief		ftHgݒǂݍ݂܂
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
static void read_profile()
{
	
	s_stGl.m_cSysOption.m_bAuto				= PROFILE_GetInt( c_sIniSectionMain, TEXT("AUTOEXEC"),	0 );
	s_stGl.m_cSysOption.m_bAtExit			= PROFILE_GetInt( c_sIniSectionMain, TEXT("ATEXIT"),	0 );
	s_stGl.m_cSysOption.m_bOutInfo			= PROFILE_GetInt( c_sIniSectionMain, TEXT("OUTINFO"),	0 );
	s_stGl.m_cSysOption.m_bBackup			= PROFILE_GetInt( c_sIniSectionMain, TEXT("BACKUP"),	0 );
	s_stGl.m_cSysOption.m_bRetexec			= PROFILE_GetInt( c_sIniSectionMain, TEXT("RETEXEC"),	0 );
	s_stGl.m_cSysOption.m_iRange			= PROFILE_GetInt( c_sIniSectionMain, TEXT("RANGE"),		0 );
	s_stGl.m_cSysOption.m_bSearchSubDir		= PROFILE_GetInt( c_sIniSectionMain, TEXT("SEARCHSUB"),	0 );
	s_stGl.m_cSysOption.m_bDefaultCurrent	= PROFILE_GetInt( c_sIniSectionMain, TEXT("DEFAULTCURRENT"),	0 );
	
//	s_stGl.m_cXcopy.SetSearchSubDir( s_stGl.m_cSysOption.m_bSearchSubDir );
	
	
	PROFILE_GetString( c_sIniSectionMain, TEXT("OUTINFONAME"), s_stGl.m_cSysOption.m_sOutInfoName, _MAX_PATH, c_sDefaultOutFile );
	PROFILE_GetString( c_sIniSectionMain, TEXT("BACKUPPATH"), s_stGl.m_cSysOption.m_sBackupPath, _MAX_PATH, TEXT("") );
	
	WINDOW_W = PROFILE_GetInt( c_sIniSectionMain, TEXT("WINDOW_W"), 480 );
	WINDOW_H = PROFILE_GetInt( c_sIniSectionMain, TEXT("WINDOW_H"), 360 );
	
	s_stGl.bFuntion_lock = PROFILE_GetInt( TEXT("EXTRA"), TEXT("LOCK"), FALSE );
}


//********************************************************************************************
/**
 * @brief		ftHgݒ݂܂
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	write_profile(){
	
	PROFILE_SetInt( c_sIniSectionMain,TEXT("AUTOEXEC"),			s_stGl.m_cSysOption.m_bAuto );
	
	PROFILE_SetInt( c_sIniSectionMain,TEXT("ATEXIT"),			s_stGl.m_cSysOption.m_bAtExit );
	PROFILE_SetInt( c_sIniSectionMain,TEXT("OUTINFO"),			s_stGl.m_cSysOption.m_bOutInfo );
	PROFILE_SetInt( c_sIniSectionMain,TEXT("BACKUP"),			s_stGl.m_cSysOption.m_bBackup );
	PROFILE_SetInt( c_sIniSectionMain,TEXT("RETEXEC"),			s_stGl.m_cSysOption.m_bRetexec );
	PROFILE_SetInt( c_sIniSectionMain,TEXT("RANGE"),			s_stGl.m_cSysOption.m_iRange );
	PROFILE_SetInt( c_sIniSectionMain,TEXT("SEARCHSUB"),		s_stGl.m_cSysOption.m_bSearchSubDir );
	PROFILE_SetInt( c_sIniSectionMain,TEXT("DEFAULTCURRENT"),	s_stGl.m_cSysOption.m_bDefaultCurrent );
	
	PROFILE_SetInt( c_sIniSectionMain, TEXT("WINDOW_W"),		WINDOW_W );
	PROFILE_SetInt( c_sIniSectionMain, TEXT("WINDOW_H"),		WINDOW_H );
	
	PROFILE_SetString( c_sIniSectionMain,TEXT("OUTINFONAME"),	s_stGl.m_cSysOption.m_sOutInfoName );
	PROFILE_SetString( c_sIniSectionMain,TEXT("BACKUPPATH"),	s_stGl.m_cSysOption.m_sBackupPath );
}


//********************************************************************************************
/**
 * @brief		profilebatch̓ǂݍ.
 * @author		N.Takeda
 * @date		2011/05/28(y) 19:34:01
 *
 * @param[in]	LPCTSTR	_pBuff	obt@.
 * @param[in]	Int32	_iLen	.
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
static void read_profile_batch( LPCTSTR _pBuff, Int32 _iLen )
{
	s_stGl.m_cBatOption = s_stGl.m_cSysOption;
	
	if( FALSE == PROBUFF_IsSection( _pBuff, _iLen, c_sSettingSectionMain ) )	return;
	
	s_stGl.m_cBatOption.m_bAuto				= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("AUTOEXEC"),		s_stGl.m_cSysOption.m_bAuto );
	s_stGl.m_cBatOption.m_bAtExit			= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("ATEXIT"),			s_stGl.m_cSysOption.m_bAtExit );
	s_stGl.m_cBatOption.m_bOutInfo			= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("OUTINFO"),		s_stGl.m_cSysOption.m_bOutInfo );
	s_stGl.m_cBatOption.m_bBackup			= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("BACKUP"),			s_stGl.m_cSysOption.m_bBackup );
	s_stGl.m_cBatOption.m_bRetexec			= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("RETEXEC"),		s_stGl.m_cSysOption.m_bRetexec );
	s_stGl.m_cBatOption.m_iRange			= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("RANGE"),			s_stGl.m_cSysOption.m_iRange );
	s_stGl.m_cBatOption.m_bSearchSubDir		= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("SEARCHSUB"),		s_stGl.m_cSysOption.m_bSearchSubDir );
	s_stGl.m_cBatOption.m_bDefaultCurrent	= PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("DEFAULTCURRENT"),	s_stGl.m_cSysOption.m_bDefaultCurrent );
	
	PROBUFF_GetString( _pBuff, _iLen, c_sSettingSectionMain, TEXT("OUTINFONAME"), s_stGl.m_cBatOption.m_sOutInfoName,	_MAX_PATH, s_stGl.m_cSysOption.m_sOutInfoName );
	PROBUFF_GetString( _pBuff, _iLen, c_sSettingSectionMain, TEXT("BACKUPPATH"), s_stGl.m_cBatOption.m_sBackupPath,		_MAX_PATH, s_stGl.m_cSysOption.m_sBackupPath );
	
#if 0
	WINDOW_W = PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("WINDOW_W"), 480 );
	WINDOW_H = PROBUFF_GetInt( _pBuff, _iLen, c_sSettingSectionMain, TEXT("WINDOW_H"), 360 );
#endif
	
	s_stGl.m_cXcopy.SetSearchSubDir( s_stGl.m_cBatOption.m_bSearchSubDir );
	
	/// ob`̐ݒɐ؂ւ.
	s_stGl.m_pOption = &s_stGl.m_cBatOption;
}


// -----^C}[
//======================================================
//		x^C}[Jn܂
//======================================================
static void TimerStart_conv( HWND hWnd )
{
	TIMECAPS	caps;
	
	s_stGl.TimerFlag = FALSE;
	
	timeGetDevCaps( &caps,sizeof(caps) );
	timeBeginPeriod( caps.wPeriodMin );
	
	s_stGl.TimerID = timeSetEvent( 66,caps.wPeriodMin,TimerFunc_conv,(DWORD)hWnd,(UINT)TIME_PERIODIC );
	
}


//======================================================
//		^C}[R[obN֐
//======================================================
static void CALLBACK TimerFunc_conv( UINT wID, UINT wUser, DWORD dwUser, DWORD dw1, DWORD dw2 )
{
	HWND	hWnd = (HWND)dwUser;
	
	T_ASSERT( s_stGl.TimerID != 0 );
	if( s_stGl.TimerFlag == FALSE )
	{
		s_stGl.TimerFlag = TRUE;
		PostMessage( hWnd,TIMER_LOOP_CONV,0,0 );
	}
}


//======================================================
//		x^C}[~܂
//======================================================
static void TimerStop( HWND hWnd, UINT &id)
{
	TIMECAPS	caps;
	
	if( id != 0 )
	{
		timeKillEvent( id );
		id = 0;
		timeGetDevCaps( &caps,sizeof(caps) );
		timeEndPeriod( caps.wPeriodMin );
		
	}
}


//==================================================
//		I[vt@C_CAOĂяo		
//==================================================
static	Bool	OpenGetFileName( HWND hWnd )
{
	TCHAR		buf[MAX_PATH], drive[_MAX_DRIVE], cDir[_MAX_DIR];
	TCHAR		Title[] = TEXT("Q");
	TCHAR		szFilter[] = TEXT("Macro Files(*.*)\0*.swb\0");
	FILESELECT	fs;
	
	
	fs.hWnd = hWnd;
	fs.szTitle = Title;
	fs.szFullPathName = buf;
	fs.szFilter = szFilter;
	fs.DefFilename = NULL;
	
	if( FILE_GetOpenFile(fs) == FALSE )	return	FALSE;
	
	STRING_cpy( s_stGl.ScriptPath, buf );
	
	// JgfBNgړ
	FILE_split( s_stGl.ScriptPath, drive, cDir, NULL, NULL );
	FILE_merge( buf, drive, cDir, NULL, NULL );
	FILE_SetCurrentDirectory( buf );
	
	SetWindowText( s_stGl.hScriptPath, s_stGl.ScriptPath );
	Read_SWriterBatch( s_stGl.ScriptPath );
	
	return	TRUE;
}


//********************************************************************************************
/**
 * @brief		section̎擾.
 * @author		N.Takeda
 * @date		2010/09/15() 01:01:12
 *
 * @param[in]	LPCTSTR	_pPtr	؃obt@|C^.
 *
 * @return		Int32	0:Ȃ 1:XNvg 2:t@C
 */
//********************************************************************************************
static	Int32	get_section( LPCTSTR _pPtr )
{
	const	Int32	STRING_MAX = 32;
	Int32		ii;
	TCHAR	sTemp[ STRING_MAX ];
	
	
	if(*_pPtr != '[')	return	0;
	_pPtr++;
	
	ii = 0;
	while(*(_pPtr+ii) != ']' && *(_pPtr+ii) != 0 && ii<STRING_MAX){
		sTemp[ii] = *(_pPtr+ii);
		ii++;
	}
	sTemp[ii] = 0;
	
	STRING_ToBig( sTemp );
	
	if( STRING_cmp( sTemp, TEXT("SCRIPT")) == 0 )	return	1;
	if( STRING_cmp( sTemp, TEXT("FILES")) == 0 )	return	2;
	
	
	return 0;
}


/// 񂩂@R}hƃp[^ɕ (ezParamɓł͂)
static	void	GetCommandParam( SCRIPT_STAT *pSStat, xstring sString ){
	xstring::iterator	it;
	
	
	it = sString.begin();
	
	pSStat->sCommand.clear();
	pSStat->sParam.clear();
	
	while( it != sString.end() && *it!=' ' && *it!='\t' && *it!='\r' && *it!='\n' )
	{
		TCHAR	cCh = *it;
		
		if( cCh >= 'a' && cCh <= 'z' )	cCh = cCh - ('a'-'A');
		
		pSStat->sCommand.append( 1, cCh );
		it++;
	}
	
	if( it != sString.end() )
	{
		while( it != sString.end() && (*it==' ' || *it=='\t') )	it++;
	}

	if( it != sString.end() )
	{
		while( it != sString.end() && *it!='\r' && *it!='\n' )
		{
			pSStat->sParam.append( 1, *it );
			it++;
		}
	}
	
}

/// ob`t@C̃XNvgZbg
static	void	set_script( LPCTSTR _pPtr, Int32 _iLen )
{
	SCRIPT_STAT	SStat;
	xstring		sString;
	Int32			ii;
	
	
	if( s_stGl.bFuntion_lock )	return;
	
	ii = 0;
	while( ii < _iLen )
	{
		sString.clear();
		
		while( ii<_iLen && *(_pPtr + ii)!='\r' && *(_pPtr + ii)!='\n' )
		{
			sString.append( 1, *(_pPtr + ii++) );
		}
		GetCommandParam( &SStat, sString );
		
		while( ii<_iLen && (*(_pPtr + ii)=='\r' || *(_pPtr + ii)=='\n') )	ii++;
		
		s_stGl.m_stScrStat.push_back( SStat );
	}
	
#ifdef DEBUG_OUT_BATCMD
	DEBUG_printf(TEXT("batcmd.txt"),TEXT("Commands %s\r\n"), s_stGl.ScriptPath );
	for(LScriptStat::iterator it = s_stGl.m_stScrStat.begin() ; it != s_stGl.m_stScrStat.end() ; it++)
	{
		DEBUG_printf(TEXT("batcmd.txt"),TEXT("%s(%s)\r\n"), it->sCommand.c_str(), it->sParam.c_str() );
	}
#endif
	
}


Bool FileReadUpdate( void *_pParam )
{
	WINDOW_INFO	*pWin = (WINDOW_INFO*)_pParam;
	
/*	
{
	SendMessage( s_stGl.hFlist,LB_RESETCONTENT,0,0 );
}
	List_show();
*/
	Int32	iEntry = s_stGl.m_cXcopy.GetEntry();
	TCHAR	str[32];
	wsprintf( str, TEXT("Entry : %3d"), iEntry );
	SetWindowText( s_stGl.hEntry, str );
	
//	UpdateWindow( pWin->m_hWnd );
	WINDOW_Update( *pWin, SW_SHOW );
	
	return FALSE;
}

//**************************************************************
//		ob`t@Ct@CXg𓾂
//**************************************************************
static	void	get_files( LPCTSTR _pPtr, Int32 len )
{
	Int32					ii, jj, idx, entry;
	TCHAR				temp[ _MAX_PATH ];
	
	
	/// 𒲂ׂ
	ii = entry = 0;
	idx = -1;
	while( ii < len )
	{
		jj = 0;
		while( ii < len )
		{
			if( *(_pPtr+ii) == '\r' || *(_pPtr+ii) == '\n' )	break;
#ifndef	_UNICODE
			if( _ismbblead(*(_pPtr+ii)) != 0 )	temp[jj++] = *(_pPtr+ii++);
#endif
			temp[jj++] = *(_pPtr+ii++);
		}
		temp[jj] = 0;
		while( (*(_pPtr+ii) == '\r' || *(_pPtr+ii) == '\n' || *(_pPtr+ii) == '\t') && ii<len)	ii++;
		
		
		s_stGl.m_cXcopy.SetUpdateFunc( FileReadUpdate, &s_cWin, 60 );
		
		s_stGl.m_cXcopy.AddXcopy( temp );
	}
}


#if 0
//--------------------------------------------------------------
//		
//			-option Oo[W
//--------------------------------------------------------------
void	filt_small2big( LPTSTR _pPtr, DWORD length, char strch )
{
	Int32			ii,ff;
	
	
	ff = 1;
	for(ii=0 ; ii<(Int32)length ; ii++){
		if(*(_pPtr+ii) == strch)	ff = 1 - ff;
		if(*(_pPtr+ii) == '-')		while(*(_pPtr+ii-1) != '\n' && ii<(Int32)length)	ii++;	//	-IvV͏Ȃ
		
		if(ff == 1){
#ifndef	_UNICODE
			if( _ismbblead(*(_pPtr+ii)) != 0)
				ii++;
			else
#endif
			if(*(_pPtr+ii) >= 'a' && *(_pPtr+ii) <= 'z')	*(_pPtr+ii) -= ('a' - 'A');
		}
	}
	
}
#endif


//********************************************************************************************
/**
 * @brief		SWriterob`ǂݍ
 * @author		N.Takeda
 *
 * @param[in]	LPCTSTR	_pFName	.
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	Read_SWriterBatch( LPCTSTR _pFName )
{
	TCHAR		*pMem = NULL;
	Int32		ii, iScLen, iLen;
	
	
	/// ob`t@Cǂ
	iLen = MEM_TextRead( &pMem, _pFName );
	if(iLen == 0)
	{	/// ob`t@C݂Ȃꍇ̓R}hƔf
	/*	
		SCRIPT_STAT	SStat;
		
		SStat.sCommand.clear();
		SStat.sParam.clear();
		
		SStat.sCommand = _pFName;
		
		s_stGl.m_stScrStat.push_back( SStat );
	*/	
		return FALSE;
	}
	
	/// ߍ폜
	iLen = FILT_deleteREM( pMem, iLen, TEXT("//"), TEXT("/*"), TEXT("*/"), '\"' );

//	/// ->啶(-option O)
//	filt_small2big( pMem,iLen,'\"');			///< QȂ̂Ŕp~. N.Takeda 2010/09/15
	
	read_profile_batch( pMem, iLen );
	
	{
		//! ϐWJ.
		TCHAR	sEnv[ 256 ];
		Int32	jj = 0, iTempLen = 0;
		TCHAR	*pTemp = NULL;
		
		mem_alloc( TCHAR, pTemp, iLen * 3 );
		ii = 0;
		while( ii < iLen )
		{
			if( *(pMem+ii) == '%' )
			{
				ii++;
				while( ii < iLen && ('0' <= *(pMem+ii) && *(pMem+ii) <= '9' || 'A' <= *(pMem+ii) && *(pMem+ii) <= 'Z' || 'a' <= *(pMem+ii) && *(pMem+ii) <= 'z' || *(pMem+ii) == '_') && *(pMem+ii) != '%' )
				{
					sEnv[ jj++ ] = *(pMem+ii++);
				}
				sEnv[ jj ] = '\0';
				
				if( ENV_GetStr( pTemp + iTempLen, 256, sEnv, TRUE ) )
				{
					iTempLen += STRING_len(pTemp);
				}else{
					*(pTemp + iTempLen++) = '%';
					STRING_cpy( pTemp + iTempLen, sEnv );
					iTempLen += STRING_len(sEnv);
				}
			//	ii++;
				continue;
			}
			*(pTemp + iTempLen++) = *(pMem+ii++);
		}
		*(pTemp + iTempLen) = '\0';
		
		del_alloc( pMem );
		iLen = iTempLen;
		pMem = pTemp;
	}
	
	ii = 0;
	while( ii < iLen )
	{
		switch( get_section( pMem + ii ) )
		{
			case 1:	///< [SCRIPT]
				
				while( ii < iLen && *(pMem+ii) != ']' )
				{
#ifndef	_UNICODE
					if( _ismbblead(*(pMem+ii)) != 0 )	ii++;
#endif
					ii++;
				}
				if(*(pMem+ii) == ']')	ii++;
				while(*(pMem+ii) < ' ')	ii++;
				iScLen = 0;
				while( ii+iScLen < iLen && *(pMem+ii+iScLen) != '[' )
				{
#ifndef	_UNICODE
					if( _ismbblead(*(pMem+ii+iScLen)) != 0)	iScLen++;
#endif
					iScLen++;
				}
				while( iScLen>0 && (*(pMem+ii+iScLen-2)=='\r' || *(pMem+ii+iScLen-1)=='\n') )	iScLen -= 2;
				
				set_script( pMem+ii, iScLen );
				
				break;
			
			case 2:	///< [FILES]
				
				while( ii < iLen && *(pMem+ii) != ']' )
				{
#ifndef	_UNICODE
					if( _ismbblead(*(pMem+ii)) != 0 )	ii++;
#endif
					ii++;
				}
				if(*(pMem+ii) == ']')	ii++;
				while(*(pMem+ii) < ' ')	ii++;
				iScLen = 0;
				while( ii+iScLen < iLen && *(pMem+ii+iScLen) != '[' )
				{
#ifndef	_UNICODE
					if( _ismbblead(*(pMem+ii+iScLen)) != 0)	iScLen++;
#endif
					iScLen++;
				}
				
				get_files( pMem+ii, iScLen );
				
				break;
			default:
				ii++;
		}
	}
	
	del_alloc( pMem );
	
	Message_script();
	
	return TRUE;
}


//==================================================
//		G[bZ[W\						
//==================================================
void	Message_error( LPCTSTR format, ... )
{
	#define		MESSAGE_ERRORLENGTH	(1024)
	TCHAR	str[MESSAGE_ERRORLENGTH];
	va_list	args;
	
	va_start( args,format );
//	vsprintf_s( str, MESSAGE_ERRORLENGTH, format, args );
	_vsntprintf_s( str, MESSAGE_ERRORLENGTH, format, args );
	va_end( args );
	
	Message_win( str );
	s_stGl.iErrors++;
}


//==================================================
//		bZ[W\								
//==================================================
void	Message_printf( LPCTSTR format, ... )
{
	TCHAR	str[MESSAGE_1MAX];
	va_list	args;
	
	va_start( args,format );
//	vsprintf_s( str,MESSAGE_1MAX,format,args );
	_vsntprintf_s( str, MESSAGE_1MAX, format, args );
	va_end( args );
	
	Message_win( str );
}


//********************************************************************************************
/**
 * @brief		bZ[W\.
 * @author		N.Takeda
 * @date		2011/05/17() 10:49:16
 *
 * @param[in]	LPCTSTR	_pStr	.
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	Message_win( LPCTSTR _pStr )
{
	const Int32	iTextBoxBuffSize = 30000;
	const TCHAR	sCrlf[] = TEXT("\r\n");
	
	Int32			iLen;
	Int32			iStrlen = STRING_len( _pStr ) * sizeof(TCHAR);
	
	if( iStrlen < 256 )	iStrlen = 256;
	
	T_ASSERT( s_stGl.m_memMsg );
	
	if( STRING_len(s_stGl.m_memMsg) > s_iMIsize - MESSAGE_1MAX )
	{
		/// eʃI[o[.
		TCHAR	*pMem = NULL;
		
		mem_alloc( TCHAR, pMem, s_iMIsize + MESSAGEINFO_SIZE );
		BUF_copy( pMem, s_stGl.m_memMsg, s_iMIsize * sizeof(TCHAR) );
		mem_del(s_stGl.m_memMsg);
		
		s_stGl.m_memMsg = pMem;
		
		s_iMIsize += MESSAGEINFO_SIZE;
		TRACE( TEXT("obt@TCYXV(%d)\n"), s_iMIsize );
	}
	
	/// obt@֕̒ǉ.
	STRING_cat( s_stGl.m_memMsg, _pStr );
	STRING_cat( s_stGl.m_memMsg, sCrlf );
	
	/// {bNX֕̒ǉ.
	iLen = SendMessage( s_stGl.hInfo, WM_GETTEXTLENGTH, 0, 0 );
	if( iTextBoxBuffSize - iStrlen < iLen )
	{
		/// eLXg{bNX̃obt@I[o[ȎA擪.
		TCHAR	sWork[ iTextBoxBuffSize ];
		GetWindowText( s_stGl.hInfo,  sWork, sizeof(sWork) );
		
		Int32	ii = 0;
		for( ii = iStrlen ; ii<iTextBoxBuffSize ; ii++ )
		{
			if( '\r' == sWork[ ii ] && '\n' == sWork[ ii+1 ] )	break;
		}
		if( ii < iTextBoxBuffSize )
		{
			ii += 2;													///< s̕.
		}else{
			sWork[ 0 ] = '\0';
			ii = 0;
		}
		SendMessage( s_stGl.hInfo, EM_SETSEL, 0, -1 );
		SendMessage( s_stGl.hInfo, EM_REPLACESEL, 0, (LPARAM)(&sWork[ ii ]) );
	}
	
	SendMessage( s_stGl.hInfo, EM_SETSEL, iLen, iLen );					///< I[IĒǉȂƓ쒆ɃXN[o[𑀍삳ꂽɖɕtȂ.
	SendMessage( s_stGl.hInfo, EM_REPLACESEL, 0, (LPARAM)_pStr );
	SendMessage( s_stGl.hInfo, EM_REPLACESEL, 0, (LPARAM)sCrlf );
	
//	SendMessage( s_stGl.hInfo, EM_SCROLL, SB_LINEDOWN,0 );
	
	UpdateWindow(s_stGl.hInfo);
}


//==================================================
//		bZ[WNA
//==================================================
void	Message_clear()
{
	T_ASSERT( s_stGl.m_memMsg );
	
	SendMessage( s_stGl.hInfo,WM_SETTEXT,0,(LPARAM)(LPCTSTR)"" );
	UpdateWindow(s_stGl.hInfo);
	
	s_stGl.m_memMsg[0] = 0;
	
}


//********************************************************************************************
/**
 * @brief		XNvg\.
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	Message_script()
{
	TCHAR	cTemp[ 1024 ];
	
	if( !s_stGl.m_stScrStat.empty() )
	{
		for(LScriptStat::iterator it = s_stGl.m_stScrStat.begin() ; it != s_stGl.m_stScrStat.end() ; it++)
		{
			wsprintf(cTemp, TEXT("%s %s"), it->sCommand.c_str(), it->sParam.c_str() );
			Message_win( cTemp );
		}
	}
	
}


/// pXt@Ĉ݂o
LPCTSTR	pickup_name( LPCTSTR _pp )
{
	TCHAR	cDrive[_MAX_DRIVE], cDir[_MAX_DIR];
	
	FILE_split( _pp, cDrive, cDir, NULL, NULL);
	
	return (_pp + STRING_len(cDrive) + STRING_len(cDir));
}


static	void	set_messagepath( LPTSTR path )
{
	TCHAR	cDrive[_MAX_DRIVE],cDir[_MAX_DIR];
	
	FILE_split( path,cDrive,cDir,NULL,NULL);
	FILE_merge( s_stGl.MessagePath,cDrive,cDir,NULL,NULL);
}


//********************************************************************************************
/**
* @brief		bZ[Weo
* @author		N.Takeda
*
* @param[in,out]	LPTSTR	_pOutName	
*
* @return		Ȃ (none)
*/
//********************************************************************************************
static	void	out_infomessage( LPTSTR _pOutName )
{
	TCHAR		cPath[ _MAX_PATH ], cDrive[ _MAX_DRIVE ], cDir[ _MAX_DIR ], cName[ _MAX_FNAME ], temp[ _MAX_FNAME ];
	T_ASSERT( s_stGl.m_memMsg );
	
	
	FILE_split( s_stGl.ScriptPath, NULL, NULL, cName, NULL );
	FILE_split( s_stGl.MessagePath, cDrive, cDir, NULL, NULL );
	
	if( _pOutName[ 0 ] != 0 )	///< o̓t@Cw
	{
		if( *(_pOutName + 1) == ':' )	STRING_cpy( cPath, _pOutName );	///< tpX.
		else							FILE_merge( cPath, cDrive, cDir, _pOutName, NULL );
		
		FILE_TextWrite( cPath, s_stGl.m_memMsg );
	}else{	//o͐wȂ
		STRING_cpy( temp, TEXT("res_") );
		STRING_cat( temp, cName );
		
		FILE_merge( cPath, cDrive, cDir, temp, TEXT(".txt") );
		FILE_TextWrite( cPath, s_stGl.m_memMsg );
	}
	
}




//==============================================================================================================================
//		̑
//==============================================================================================================================

//********************************************************************************************
/**
 * @brief		file_backup֐
 * @author		N.Takeda
 * @date		2009/08/14() 19:48:06
 *
 * @param[in]	LPCTSTR	_pFName	
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	file_backup( LPCTSTR _pFName )
{
	TCHAR		cWork[_MAX_PATH], cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_FNAME], cExt[_MAX_EXT];
	
	
	if( FILE_GetFileSize(_pFName) > 0 )		///< t@Cɑ
	{
		if( s_stGl.m_pOption->m_bBackup == 1 )
		{
			/// obNAbv쐬
			FILE_split( _pFName, cDrive, cDir, cName, cExt );
			if( s_stGl.m_pOption->m_sBackupPath[ 0 ] != 0 ){
				FILE_merge( cWork, NULL, s_stGl.m_pOption->m_sBackupPath, cName, cExt );
			}else
				FILE_merge( cWork, cDrive, cDir, cName, TEXT(".bak") );
			
			if( FILE_GetFileSize(cWork) > 0 )	FILE_delete(cWork);	///< ɓ̃obNAbvt@Cꍇ͏
			if( FILE_rename( _pFName, cWork ) == -1 )				///< t@C̃l[
			{
				Message_printf( TEXT("%s\nobNAbvt@C쐬ł܂"), _pFName );
				return TRUE;
			}
		}else{
			wsprintf( cWork, TEXT("%s\nɃt@C݂܂B㏑܂H"), _pFName );
			switch( MessageBox( s_cWin.m_hWnd, cWork, TEXT("₢킹"), MB_YESNOCANCEL ) )
			{
				case IDYES:
					break;
				case IDNO:
					return TRUE;
				case IDCANCEL:
					s_stGl.bFlagStop = TRUE;
					return TRUE;
			}
		}
	}
	
	return FALSE;
}

//********************************************************************************************
/**
 * @brief		t@Co
 *				m_bBackuptOZbgĂ΃obNAbvƂ
 *
 * @author		N.Takeda
 * @date		2009/08/14() 14:55:00
 *
 * @param[in]		LPCTSTR	_pFName	
 * @param[in,out]	char*	_pPtr	|C^
 * @param[in]		Int32	_iSize	TCY
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	file_targetwrite( LPCTSTR _pFName, char *_pPtr, Int32 _iSize )
{
	TCHAR		cPath[_MAX_PATH], cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_FNAME], cExt[_MAX_EXT];
	TCHAR		cWork[ 256 ];
	Bool		bRes;
	
	
	if( _iSize == 0 )
	{
		Message_error( TEXT("OutFileSize zero.%s"), pickup_name(_pFName) );
		return FALSE;
	}
	
	if( file_backup( _pFName ) )	return FALSE;
	
	bRes = FILE_TargetWrite( _pFName, _pPtr, _iSize );
	if(bRes == 0)
	{
		/// t@C߂ȂtH_쐬Ă݂
		FILE_MakeDirectory(_pFName);
		
		/// x
		bRes = FILE_TargetWrite( _pFName, _pPtr, _iSize );
		if( bRes == 0 )
		{
			if( _pFName[1] != ':' )
			{
				/// łȂA΃pXw肾ꍇ̓ob`t@C̃tpX쐬
				FILE_split( s_stGl.ScriptPath, NULL, cDir, NULL, NULL );
				FILE_split( _pFName, cDrive, cWork, cName, cExt );
				STRING_cat( cDir, cWork );
				FILE_merge( cPath, cDrive, cDir, cName, cExt );
				FILE_MakeDirectory( cPath );
				bRes = FILE_TargetWrite( cPath, _pPtr, _iSize );
			}
			if( bRes == 0 )
				Message_error( TEXT("Can't write file.%s"), pickup_name(_pFName) );
		}
	}
	
	return bRes;
}


//********************************************************************************************
/**
* @brief		file_textwrite֐
* @author		N.Takeda
* @date		2009/08/14() 19:48:02
*
* @param[in]	LPCTSTR	_pFName	
* @param[in]	LPCTSTR	_pPtr	|C^
*
* @return		Bool	TRUE: / FALSE:
*/
//********************************************************************************************
Bool	file_textwrite( LPCTSTR _pFName, LPCTSTR _pPtr )
{
	TCHAR		cPath[_MAX_PATH], cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_FNAME], cExt[_MAX_EXT];
	TCHAR		cWork[ 256 ];
	Bool		bRes;
	
	
	if( STRING_len( _pPtr ) == 0 )
	{
		Message_error( TEXT("OutFileSize zero.%s"), pickup_name(_pFName) );
		return FALSE;
	}
	
	if( file_backup( _pFName ) )	return FALSE;
	
	bRes = FILE_TextWrite( _pFName, _pPtr );
	if(bRes == 0)
	{
		/// t@C߂ȂtH_쐬Ă݂
		FILE_MakeDirectory(_pFName);
		
		/// x
		bRes = FILE_TextWrite( _pFName, _pPtr );
		if( bRes == 0 )
		{
			if( _pFName[1] != ':' )
			{
				/// łȂA΃pXw肾ꍇ̓ob`t@C̃tpX쐬
				FILE_split( s_stGl.ScriptPath, NULL, cDir, NULL, NULL );
				FILE_split( _pFName, cDrive, cWork, cName, cExt );
				STRING_cat( cDir, cWork );
				FILE_merge( cPath, cDrive, cDir, cName, cExt );
				FILE_MakeDirectory( cPath );
				bRes = FILE_TextWrite( cPath, _pPtr );
			}
			if( bRes == 0 )
				Message_error( TEXT("Can't write file.%s"), pickup_name(_pFName) );
		}
	}
	
	return bRes;
}


//		
void	defaultpath( LPTSTR saki, LPCTSTR moto )
{
	TCHAR		cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_FNAME], cExt[_MAX_EXT];
	
	
	if(moto[1] == ':'){	//	tpX
		STRING_cpy( saki, moto );
	}else{
		FILE_split( moto, NULL, NULL, cName, cExt );
		FILE_split( s_stGl.ScriptPath, cDrive, cDir, NULL, NULL );
		
		FILE_merge( saki, cDrive, cDir, cName, cExt );
	}
	
}


//********************************************************************************************
/**
 * @brief		OW[s
 * @author		N.Takeda
 * @date		2008/5/14
 *
 * @param[in]	LPCTSTR	_pCommand		R}h.
 * @param[in]	LPCTSTR	_sParamString	p[^.
 *
 * @return		BOOL	TRUE: / FALSE:
 */
//********************************************************************************************
BOOL	swriter_ExecModule( LPCTSTR _pCommand, LPCTSTR _sParamString )
{
	xstring	sWork;
	
#ifdef PROCESS_NO_WAIT
	/// vZXI҂Ȃo[W.
	sWork = _pCommand;
	sWork += " " + _sParamString;
	
	if(WinExec( (char*)sWork.c_str(), SW_SHOW) < 32)
	{
		sWork = APP_NAME;
		sWork += " ";
		sWork += _pCommand;
		
		if(WinExec( (char*)sWork.c_str(), SW_SHOW) < 32)
		{
			Message_error("Can't exec module. \"%s\" ", (char*)sWork.c_str() );	///< G[.
		}else{
			/// swriterob`sꍇ͏I.
			s_stGl.err = 1;
		}
		
	}
#else
	STARTUPINFO			si;
	PROCESS_INFORMATION	pi;
	BOOL				bRes;
	
	ZeroMemory( &si, sizeof( STARTUPINFO ));
	si.cb          = sizeof( STARTUPINFO );
	si.dwFlags     = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_SHOWNORMAL;
	
	bRes = FALSE;
	
	sWork = _pCommand;
	sWork += TEXT(" ");
	sWork += _sParamString;
	
	bRes = CreateProcess( NULL,
		(LPTSTR)sWork.c_str(),	///< R}hC.
		NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
	
	if( bRes == FALSE )
	{
		sWork = s_stGl.MainPath;
		sWork += APP_NAME;
		sWork += TEXT(" ");
		sWork += _pCommand;
		
		bRes = CreateProcess( NULL,
			(LPTSTR)sWork.c_str(),	///< R}hC.
			NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
	}
	
	if( bRes )
	{
		Message_printf( TEXT("Process. %s"), _pCommand );
		
		/// Xbhnh͎gȂ̂őɊJ.
		CloseHandle(pi.hThread);
		
		/// NvZX̏I҂.
		WaitForSingleObject( pi.hProcess, INFINITE );
		
		/// vZXnhJ.
		CloseHandle(pi.hProcess);
		
#if 0
		/// swriterob`s͑St@Cɑ΂čsȂ.
		s_stGl.m_iIdx = (int)s_stGl.m_cXcopy.GetEntry() - 1;
#endif
	}else{
		Message_error( TEXT("Can't exec module. \"%s\""), sWork.c_str() );	///< G[.
	}
	
#endif
	return TRUE;
}


//********************************************************************************************
/**
 * @brief		|C^ƑSpr(}`oCg݊p)
 * @author		N.Takeda
 * @date		2009/08/14() 18:30:49
 *
 * @param[in]	LPCTSTR	_pPtr	|C^
 * @param[in]	WCHAR	_cCh	
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	wchar_cmp( LPCTSTR _pPtr, WCHAR _cCh )
{
#ifdef	_UNICODE
	return ( *(_pPtr) == _cCh );
#else
	return ( *(WORD*)(_pPtr) == swap_word(_cCh) );
#endif
}


//********************************************************************************************
/**
 * @brief		IvVevobt@ɓWJ.
 * @author		N.Takeda
 * @date		2011/12/06() 17:05:51
 *
 * @param[in]		LPCTSTR		_pSection	ZNV.
 * @param[in,out]	LPTSTR		_pSwb		ǉo̓obt@.
 * @param[in]		const Int32	_iSwbSize	obt@TCY.
 * @param[in]		LPCTSTR		_pCommLine	R}hC|C^.
 * @param[in]		LPCTSTR		_pOption	IvV(-܂).
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	catTempScript( LPCTSTR _pSection, LPTSTR _pSwb, const Int32 _iSwbSize, LPCTSTR _pCommLine, LPCTSTR _pOption )
{
	Int32	ii = 0, iStart;
	Bool	bInnerString = FALSE;
	Bool	bResult = FALSE;
	TCHAR	cTemp[ 64 ];
	
	
	LPTSTR	pPtr = STRING_str( _pCommLine, _pOption );
	if( !pPtr )	return FALSE;
	
	STRING_printf( cTemp, 64, TEXT("[%s]\r\n"), _pSection );
	
	pPtr += 2;
	STRING_cat( _pSwb, cTemp );
	
	iStart = ii = STRING_len( _pSwb );
	while( !(*pPtr == '-' && !bInnerString) && *pPtr != 0 && ii < _iSwbSize )
	{
		if( *pPtr == '\"' && *(pPtr-1) != '\\' )
			bInnerString = 1 - bInnerString;
		else if( *pPtr == '\"' && *(pPtr-1) == '\\' )
		{
			ii--;
			_pSwb[ ii++ ] = *pPtr;
		}else if( *pPtr == ';' )
		{
			_pSwb[ ii++ ] = '\r';
			_pSwb[ ii++ ] = '\n';
		}else
			_pSwb[ ii++ ] = *pPtr;
		pPtr++;
	}
	while( ii > 1 && _pSwb[ ii-1 ] <= ' ' )	ii--;
	_pSwb[ ii ] = '\0';
	if( _pSwb[ iStart ] == '"' && _pSwb[ ii-1 ] == '"' )	//!< Oオ " ŊĂ ".
	{
		_pSwb[ ii-1 ] = '\0';
		BUF_copy( &_pSwb[ iStart ], &_pSwb[ iStart+1 ], (ii-iStart)*sizeof(TCHAR) );
	}
	
	STRING_cat( _pSwb, TEXT("\r\n") );
	
	return TRUE;
}


//********************************************************************************************
/**
 * @brief		ɒɃXNvgw肵Ă鎞Aevt@CɓWJ.
 * @author		N.Takeda
 * @date		2011/11/17() 14:25:57
 *
 * @param[in]	LPCTSTR	_pCmdLine	R}hC.
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	MakeTempScript( LPCTSTR _pCmdLine )
{
	#define	SWB_BUFFMAX	(1024 * 2)
	
	TCHAR	cSwb[ SWB_BUFFMAX ];
	
	_zero( cSwb );
	
	catTempScript( TEXT("script"), cSwb, SWB_BUFFMAX, _pCmdLine, TEXT("-s") );
	catTempScript( TEXT("files"), cSwb, SWB_BUFFMAX, _pCmdLine, TEXT("-f") );
	catTempScript( TEXT("setting"), cSwb, SWB_BUFFMAX, _pCmdLine, TEXT("-o") );
	
	if( cSwb[ 0 ] != '\0' )
	{
		FILE_GetCurrentDirectory( c_sTempSwbPath );
		catyen( c_sTempSwbPath );
		STRING_cat( c_sTempSwbPath, c_sTempSwbName );
		
		FILE_delete( c_sTempSwbPath );
		FILE_stream( c_sTempSwbPath, cSwb );
		
		STRING_cpy( s_stGl.ScriptPath, c_sTempSwbPath );
		
		/// Œ肳ݒ.
		s_stGl.m_pOption->m_bAuto = TRUE;						///< N.
		s_stGl.m_pOption->m_bAtExit = TRUE;						///< @N㎩I.
		
		return TRUE;
	}
	return FALSE;
}


//==============================================================================================================================
//		͈͌@\
//==============================================================================================================================

//********************************************************************************************
/**
 * @brief		RXgN^
 * @author		N.Takeda
 * @date		2009/08/14() 18:25:05
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
CRANGE_CTRL::CRANGE_CTRL()
 : m_bMode( FALSE )
 , m_bSwitch( FALSE )
{
	
}

//********************************************************************************************
/**
 * @brief		͈͎w菉
 *				O[o s_stGl.m_pOption->m_iRange QƂĂ
 * @author		N.Takeda
 * @date		2009/08/14() 18:25:03
 *
 * @param[in]	LPCTSTR	_mem	
 * @param[in]	Int32	_iLen	
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	CRANGE_CTRL::Init( LPCTSTR _mem, Int32 _iLen )
{
	Int32		ii, flg;
	
	/// ϐ
	m_bSwitch = FALSE;
	
	
	m_bMode = FALSE;		///< Ȃ
	if( s_stGl.m_pOption->m_iRange == 0 )	return;		///< ͈͌Ȃ
	m_bMode = TRUE;		///< 肷
	if( s_stGl.m_pOption->m_iRange == 1 )	return;		///< ͈͂肷
	
	/// L܂݌
	flg = 0;
	for( ii=0 ; ii<_iLen ; ii++ )
	{
		if( wchar_cmp( _mem + ii, RANGECHAR_TOP ) && wchar_cmp( _mem + ii + sizeof(TCHAR), RANGECHAR_TOP ) ){
			flg |= 1;	///< JnL
		}else if( wchar_cmp( _mem + ii, RANGECHAR_BOTTOM ) && wchar_cmp( _mem + ii + sizeof(TCHAR), RANGECHAR_BOTTOM ) ){
			flg |= 2;	///< IL
		}
		if(flg == 3)	break;
	}
	/// JnLAILɂȂ
	if(flg != 3)	m_bMode = FALSE;	///< Ȃ
	
}

//********************************************************************************************
/**
 * @brief		͈͎w蔻
 * @author		N.Takeda
 * @date		2009/08/14() 18:24:59
 *
 * @param[in]	LPCTSTR	_mem	
 * @param[in]	Int32	_ii		
 * @param[in]	Int32	_iLen	
 *
 * @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
Bool	CRANGE_CTRL::Is( LPCTSTR _mem, Int32 _ii, Int32 _iLen )
{
	
	if( m_bMode == FALSE )	return FALSE;	///< Ȃ
	if( _ii+5 >= _iLen )	return FALSE;
	
	if( m_bSwitch == 0 )
	{
		if( wchar_cmp(_mem + _ii, RANGECHAR_TOP ) && wchar_cmp(_mem + _ii + sizeof(TCHAR), RANGECHAR_TOP ) ){
			m_bSwitch = TRUE;
			return FALSE;
		}
		return TRUE;
	}else{
		if( wchar_cmp(_mem + _ii, RANGECHAR_BOTTOM ) && wchar_cmp(_mem + _ii + sizeof(TCHAR), RANGECHAR_BOTTOM ) ){
			m_bSwitch = FALSE;
		}
	}
	return FALSE;
}

