//==============================================================================================================================
//	XNvg`FbN
//
//
//==============================================================================================================================

#define	SW_MODULE_CHECKSCR

#define	FNAME_MAXLEN	16
#define	FILE_MAX		(1024*8)
#define	FILENAME(num)	(m_pFileList+FNAME_MAXLEN*num)



//------------------------------------------------------------------
//		XNvgR}hNX
//------------------------------------------------------------------
class CHECKSCR{
	
	enum REMTYPE{
		REMTYPE_NOTHING,	//	Ȃ
		REMTYPE_CPP,		//	C꒍߂O
		REMTYPE_ASM,		//	AZu߂O
		REMTYPE_PERL,		//	Perl߂O
	};
	
	BOOL		m_bInitialized;
	BOOL		m_bImplemented;
	BOOL		m_bFullInit;
	
	TCHAR		*m_pFileList;
	int			m_iFileEntry;
	int			*m_pFileUse;
	
	TCHAR		*m_pNameList;
	int			m_iNameEntry;
	
	
	REMTYPE		iSwRem;
	BOOL		bSwSort;
	BOOL		bSwNoNumber;
	BOOL		bSwFileName;
	
	
	void		Initialize( LPCTSTR filefolder, LPCTSTR param );
	
	int			check_filename( LPTSTR fname );
	int			add_filename( LPCTSTR name );
public:
	int			Func( LPCTSTR _sParamString );
//	int			Func(char *path,char *outname,char *param);
	void		Quit( BOOL _bExit );
	
	CHECKSCR();
	~CHECKSCR();
	
};

//	AvP[VN
CHECKSCR::CHECKSCR()
	: m_bInitialized( FALSE )
	, m_bImplemented( FALSE )
	, m_bFullInit( FALSE )
	, m_iFileEntry( 0 )
	, m_pFileList( NULL )
	, m_pFileUse( NULL )
	, m_pNameList( NULL )
	, m_iNameEntry( 0 )
	, iSwRem( REMTYPE_CPP )	//	1:C꒍߂O@2:AZu߂O@3:Perl߂O
	, bSwSort( TRUE )		//	1:ʂ\[g
	, bSwNoNumber( TRUE )	//	1:l݂̂̓t@CƂȂ
	, bSwFileName( FALSE )	//	1:gqw肵Ă̂t@CƂȂ
{
}
//	AvP[VI
CHECKSCR::~CHECKSCR(){
}


//==============================================================================================================================================
//	ƊJ
//		1t@C1̏ŃRv[g悤ȏꍇ͏CKv܂
//		߂ƂȂĂ Message_printf Lɂ sample.swb sƓ悭Ǝv܂B
//==============================================================================================================================================

//------------------------------------------------------------------
//		XNvgR}h̏
//			(ɕKvȂȂύX̕KvȂ)
//------------------------------------------------------------------
void	CHECKSCR::Initialize( LPCTSTR filefolder, LPCTSTR param )
{
		
		if(m_bInitialized == TRUE)	return;
		m_bInitialized = TRUE;	//	ς݃tO
		
		if(m_bFullInit == FALSE){
			m_bFullInit = TRUE;
			//	ŜʂĈxsȂ
			
			//Message_printf("Ŝ̏");
		}
		//	
		//	P̃ob`ɓXNvgQxw肳ĂȂ炱ɂ͂Qx
		//Message_printf("");
#if 0	// FILE_GetXcopy verɂꎞ
		FILEXCOPY	xcpy;
		int			ii,ent;
		char		path[_MAX_PATH],fPath[_MAX_PATH],fName[_MAX_FNAME];
		DWORD		attr;
		
		
		defaultpath( path, filefolder );
		
		FILE_GetXcopy( &xcpy, path );
		ent = xcpy.files;
		
		mem_alloc(char, m_pFileList, FNAME_MAXLEN*ent )
		m_iFileEntry = 0;
		mem_alloc(int, m_pFileUse, ent );
		
		
		mem_alloc(char,m_pNameList,FNAME_MAXLEN*FILE_MAX)
		m_iNameEntry = 0;
		
		
		for( ii = 0 ;ii < ent ;ii++ ){
			STRING_cpy( fName,(LPSTR)xcpy.mem.lpBuf + xcpy.ptr );
			xcpy.ptr += STRING_len((LPSTR)xcpy.mem.lpBuf + xcpy.ptr)+ 1;
			
			STRING_cpy( fPath,path );
			STRING_cat( fPath,fName );
			attr = GetFileAttributes( fPath );
			
			if( !(attr & FILE_ATTRIBUTE_DIRECTORY)){
				
				if(STRING_len(fName)+1 >= FNAME_MAXLEN){
					Message_error("t@C܂ %s",fName);
				}
				if(fName[0]=='\\')	STRING_cpy( FILENAME(m_iFileEntry), fName+1 );
				else				STRING_cpy( FILENAME(m_iFileEntry), fName );
				STRING_SmallToBig( FILENAME(m_iFileEntry) );
				
				m_iFileEntry++;
			}
			else{
				ii--;
				ent--;
			}
		}
		MEM_free( &xcpy.mem );
#else
		int				ii, iEntry;
		TCHAR			sPath[ _MAX_PATH ];//, fPath[ _MAX_PATH ], fName[ _MAX_FNAME ];
		FILE_XCOPY		cXcopy;
		
		
		defaultpath( sPath, filefolder );
		
		cXcopy.Clear();
		cXcopy.SetSearchSubDir( TRUE );
		cXcopy.AddXcopy( sPath );
		
		iEntry = cXcopy.GetEntry();
		
		mem_alloc( TCHAR, m_pFileList, FNAME_MAXLEN * iEntry );
		m_iFileEntry = 0;
		mem_alloc( int, m_pFileUse, iEntry );
		
		
		mem_alloc( TCHAR, m_pNameList, FNAME_MAXLEN * FILE_MAX );
		m_iNameEntry = 0;
		
		
		for( ii = 0 ;ii < iEntry ;ii++ ){
			if( STRING_len( cXcopy.GetFileName( ii ) ) >= FNAME_MAXLEN){
				Message_error( TEXT("t@C܂ %s"), cXcopy.GetFileName( ii ) );
				continue;
			}
			STRING_cpy( FILENAME(m_iFileEntry), cXcopy.GetFileName( ii ) );
			m_iFileEntry++;
		}
		
#endif
		
		
		if(param[0] == '-'){
			iSwRem = REMTYPE_NOTHING;
			bSwSort = bSwNoNumber = bSwFileName = FALSE;
			if( STRING_str( param,  TEXT("c") ) != NULL)	iSwRem = REMTYPE_CPP;		//	C꒍߂O
			if( STRING_str( param,  TEXT("a") ) != NULL)	iSwRem = REMTYPE_ASM;		//	AZu߂O
			if( STRING_str( param,  TEXT("p") ) != NULL)	iSwRem = REMTYPE_PERL;		//	Perl߂O
			if( STRING_str( param,  TEXT("s") ) != NULL)	bSwSort = TRUE;				//	ʂ\[g
			if( STRING_str( param,  TEXT("n") ) != NULL)	bSwNoNumber = TRUE;			//	l݂̂̓t@CƂȂ
			if( STRING_str( param,  TEXT("e") ) != NULL)	bSwFileName = TRUE;			//	gqw肵Ă̂t@CƂȂ
		}
		
		Message_printf( TEXT("path:%s  %d files"), filefolder, m_iFileEntry );
		
		if(iSwRem == REMTYPE_CPP)	Message_win( TEXT("C꒍߂O") );
		if(iSwRem == REMTYPE_ASM)	Message_win( TEXT("AZu߂O") );
		if(iSwRem == REMTYPE_PERL)	Message_win( TEXT("Perl߂O") );
		if(bSwSort == TRUE)			Message_win( TEXT("ʂ̓\[g܂") );
		if(bSwNoNumber == TRUE)		Message_win( TEXT("l݂̂̓t@CƔf܂") );
		if(bSwFileName == TRUE)		Message_win( TEXT("gq(sIh)̂镨̂ݔ肵܂") );
		
}


//------------------------------------------------------------------
//		XNvgR}h̏I
//			(ɕKvȂȂύX̕KvȂ)
//------------------------------------------------------------------
void	CHECKSCR::Quit( BOOL _bExit )
{
		int			ii,jj,f;
		TCHAR		temp[256];
		
		
		//	ɂ̓XNvggĂȂĂ̂Œ
		
		if(m_bImplemented == FALSE)	return;		//	ϊsĂȂȂA
		m_bImplemented = FALSE;
		
		m_bInitialized = FALSE;
		
		
		if( !m_pFileList || !m_pFileUse || !m_pNameList )	return;
		
		if(m_iNameEntry != 0){
			
			if( bSwSort )
				for(ii=0 ; ii<m_iNameEntry-1 ; ii++)
					for(jj=ii ; jj<m_iNameEntry ; jj++)
						if( STRING_cmp( m_pNameList+FNAME_MAXLEN*jj, m_pNameList+FNAME_MAXLEN*ii ) < 0 )
						{
							STRING_cpy( temp, m_pNameList+FNAME_MAXLEN*ii );
							STRING_cpy( m_pNameList+FNAME_MAXLEN*ii, m_pNameList+FNAME_MAXLEN*jj );
							STRING_cpy( m_pNameList+FNAME_MAXLEN*jj, temp );
						}
			
			Message_win( TEXT("\r\nȉ̃t@C͌܂") );
			for(ii=0 ; ii<m_iNameEntry ; ii++){
				Message_printf( TEXT("%s"), m_pNameList + FNAME_MAXLEN*ii );
			}
		}
		
		
		
		if( bSwSort )
			for(ii=0 ; ii<m_iFileEntry-1 ; ii++)
				for(jj=ii ; jj<m_iFileEntry ; jj++)
					if(STRING_cmp(FILENAME(jj),FILENAME(ii)) < 0){
						STRING_cpy(temp,FILENAME(ii));
						STRING_cpy(FILENAME(ii),FILENAME(jj));
						STRING_cpy(FILENAME(jj),temp);
						f = m_pFileUse[ii];
						m_pFileUse[ii] = m_pFileUse[jj];
						m_pFileUse[jj] = f;
					}
		
		f = 1;
		for(ii=0 ; ii<m_iFileEntry ; ii++){
			if(m_pFileUse[ii] == 0){
				if(f){Message_win( TEXT("\r\nȉ̃t@C͎gpĂ܂") );f=0;}
				Message_printf( TEXT("	%s"), FILENAME(ii) );
			}
		}
		
		f = 1;
		for(ii=0 ; ii<m_iFileEntry ; ii++){
			if(m_pFileUse[ii] > 1){
				if(f){Message_win( TEXT("\r\nȉ̃t@C͕gpĂ܂") );f=0;}
				Message_printf( TEXT("	%s  %d(s)"), FILENAME(ii), m_pFileUse[ii]);
			}
		}
		
		
		//	I
		//Message_printf("");
		
		if( _bExit == TRUE )
		{
			//	̃XNvg݂͑ȂASȏI
			//	P̃ob`ɓXNvgɕʃp[^nĂ̏
			//	ꌋʂoAŜœČʂoꍇȂǂ͂
			
			//Message_printf("I");
			
			mem_del(m_pFileList);
			mem_del(m_pFileUse);
			
			mem_del(m_pNameList);
			
		}
		
}



int		CHECKSCR::check_filename( LPTSTR fname )
{
		int		f,ii;
		TCHAR	name[_MAX_FNAME];
		
		
		f = 0;
		STRING_ToBig(fname);
		for( ii=0 ; ii<STRING_len(fname) ; ii++ )
			if(fname[ii] == '.'){
				f = 1;
				break;
			}
		
		
		for( ii=0 ; ii<m_iFileEntry ; ii++ ){
			FILE_split( FILENAME(ii), NULL, NULL, name, NULL );
			
			if(f==1){
				if(STRING_cmp( fname, FILENAME(ii) ) == 0 )	return ii;
			}else{
				if(STRING_cmp( fname, name ) == 0 )			return ii;
			}
		}
		
		return -1;
}




//==============================================================================================================================================
//	ϊ
//==============================================================================================================================================

#define	CHECKSCR_RANGE				//	defineLɂƔ͈͌@\LɂȂ

//------------------------------------------------------------------
//	ϊtB^[Tv@@\:ϊ(t@CRs[)
//			ϊȂ out Ɋւ镔͕sv
//------------------------------------------------------------------
int		CHECKSCR::Func( LPCTSTR _sParamString )
{
		CSwbParam	cParam( _sParamString );							///< p[^.
	
		TCHAR	*mem=NULL, temp[FNAME_MAXLEN+2];
		int		ii, jj, n, len, idx;
		xstring	sPath, sFilefolder, sParam;
		
		
		/// ̎o.
		sPath       = cParam.GetPath();		///< ^[Qbgt@C (GetFilePath(0)ƂĂ).
		sFilefolder = cParam.GetOutPath();	///< o̓t@CpX擾(%0ϊē).
		sParam      = cParam.GetString( cParam.SearchOption() );
		
		
		if(sFilefolder[0] == '-'){
			Message_error( TEXT("tH_w肳Ă܂") );
			return FALSE;
		}
		
		Initialize( sFilefolder.c_str(), sParam.c_str() );
		
		
		if( !m_pFileList || !m_pFileUse || !m_pNameList )	return FALSE;
		
		len = MEM_TextRead( &mem, sPath.c_str() );
		if(len == 0)	return FALSE;		//	t@CȂ
		
		
		if(iSwRem == REMTYPE_CPP)	len = FILT_deleteREM( mem, len  );		//	sߋL,͈͒ߋLn_,͈͒ߋLI_,ƂL
		if(iSwRem == REMTYPE_ASM)	len = FILT_deleteREM( mem, len, TEXT(";"), NULL, NULL );
		if(iSwRem == REMTYPE_PERL)	len = FILT_deleteREM( mem, len, TEXT("#"), NULL, NULL );
		FILT_ToBig( mem, len, 0 );		//	啶
		
		
		m_bImplemented = TRUE;	//	sς݃tO
		
		ii = 0;
		#ifdef	CHECKSCR_RANGE
		cRange.Init(mem,len);						//͈͌@\Lɂɂ͂̏
		while(cRange.Is(mem,ii,len))	ii++;		//@XLbvA[XLbv]KvBXLbvKvȊtrueԂ胋[vĂ
		#endif
		
		jj = 0;
		while(ii < len){
			#ifdef	CHECKSCR_RANGE
			while(cRange.Is(mem,ii,len))	ii++;	//	XLbv
			#endif
			
			if( STRING_IsMultiByte(*(mem+ii)) ){	//	Sp
				ii += STRING_GetMultiByte();
				continue;
			}
			if( *(mem+ii)=='\"' ){		//	w
				ii++;
				jj = 0;
				while(*(mem+ii)!='\"'){
#ifndef	_UNICODE
					if( _ismbblead(*(mem+ii)) != 0 )	//	Sp
						temp[jj++] = *(mem+ii++);
#endif
					temp[jj++] = *(mem+ii++);
					if(jj >= FNAME_MAXLEN){
						jj=0;
						while(*(mem+ii)!='\"')	ii++;
						break;
					}
					if( *(mem+ii) == ' ' || *(mem+ii) == '\t' ){
						jj=0;
						while(*(mem+ii)!='\"')	ii++;
						break;
					}
				}
				temp[jj] = 0;
				ii++;		//	"̕
				if(jj==0)	continue;		//	
			}else if(*(mem+ii)=='(' || *(mem+ii)==','){
				ii++;
				while(*(mem+ii)==' ' || *(mem+ii)=='\t')	ii++;
				
				if(*(mem+ii)=='\"')	continue;		//	w
				if( STRING_IsMultiByte(*(mem+ii)) )	continue;
				
				jj = 0;
				while(
					*(mem+ii)!=',' && 
					*(mem+ii)!='(' && 
					*(mem+ii)!=')' && 
					*(mem+ii)!='[' && 
					*(mem+ii)!=']' && 
					*(mem+ii)!='\\' && 
					*(mem+ii)!='|' && 
					*(mem+ii)!='&' && 
					*(mem+ii)!='+' && 
					*(mem+ii)!='-' && 
					*(mem+ii)!='*' && 
					*(mem+ii)!='/' && 
					*(mem+ii)!=':' && 
					*(mem+ii)!='=' && 
					*(mem+ii)!='?' && 
					*(mem+ii)!=' ' && 
					*(mem+ii)!='\t' && 
					*(mem+ii)!='\r' && 
					*(mem+ii)!='\n' && 
					*(mem+ii)!='@'){
					
#ifndef	_UNICODE
					if( _ismbblead(*(mem+ii)) != 0 )	//	Sp
						temp[jj++] = *(mem+ii++);
#endif
					temp[jj++] = *(mem+ii++);
					if(jj >= FNAME_MAXLEN){jj=0;break;}
				}
				while(*(mem+ii)==' ' || *(mem+ii)=='\t')	ii++;
				if(
					*(mem+ii)=='[' || 
					*(mem+ii)==']' || 
					*(mem+ii)=='\\' || 
					*(mem+ii)=='|' || 
					*(mem+ii)=='&' || 
					*(mem+ii)=='+' || 
					*(mem+ii)=='-' || 
					*(mem+ii)=='*' || 
					*(mem+ii)=='/' || 
					*(mem+ii)==':' || 
					*(mem+ii)=='=' || 
					*(mem+ii)=='?' || 
					*(mem+ii)=='@')	jj = 0;
				
				temp[jj] = 0;
				if(jj==0)	continue;
			}
			else
				ii++;
			
			if(jj != 0){		//	tempɉĂ
				int		f_fname,f_str,f_knj;
				
				f_fname = f_str = f_knj = 0;
				for(n=0 ; n<jj ; n++){
					if( STRING_IsMultiByte(temp[n]) ){	//	Sp
						n++;
						f_knj = f_str = 1;
						continue;
					}
					if(temp[n] == '.'){
						f_fname = 1;		//	t@Cł\
					}
					if(temp[n] < '0' || temp[n] > '9')	f_str = 1;
				}
				
				if(f_knj == 1 && f_fname == 0)			continue;	//	Sp܂܂镨'.'Ȃƃt@CƔfȂ
				if(bSwNoNumber == TRUE && f_str == 0)	continue;
				if(bSwFileName == TRUE && f_fname == 0)	continue;
				
				idx = check_filename(temp);
				if(idx != -1){
					m_pFileUse[idx]++;
				//	Message_printf("file: %s %d",temp,m_pFileUse[idx]);
				}else{
					add_filename(temp);
				}
				jj = 0;
			}
			
		}
		
		
		//	J
		mem_del(mem);
		
		return TRUE;
}


//		
int		CHECKSCR::add_filename( LPCTSTR name )
{
		int		ii;
		
		
		for(ii=0 ; ii<m_iNameEntry ;ii++){
			if(STRING_cmp((m_pNameList + FNAME_MAXLEN*ii),name)==0)	return 0;
		}
		
		STRING_cpy((m_pNameList + FNAME_MAXLEN*ii),name);
		m_iNameEntry++;
		
		return 1;
}


CHECKSCR	*pC_checkscr = NULL;

