//==============================================================================================================================
//	֑
//
//
//==============================================================================================================================
#define	SW_MODULE_KINSOKU

#define		NAME_MAX		(16)

//------------------------------------------------------------------
//		XNvgR}hNX
//------------------------------------------------------------------
class KINSOKU{
	
	BOOL		m_bInitialized;
	BOOL		m_bImplemented;
	BOOL		m_FullInit;
	
	void		Initialize(char *param,char *namelist);
	int			string_cmp(char *ptr,char *str);
	
	int			read_namelist(char *fname);
	int			check_kinsoku(char *ptr);
	
	char		crlf[5];
	int			width,hight;
	char		name[NAME_MAX][32];				//
	int			nlen_min[NAME_MAX];				//
	int			nlen_max[NAME_MAX];				//
	int			name_entry;
	
public:
	int			Func( CPARAMS cParams );
//	int			Func(char *path,char *param,char *namelist,char *outname);
	void		Quit( BOOL _bExit );
	
	void		kinsoku(char *mess);
	
	KINSOKU();
	~KINSOKU();
	
};

//	AvP[VN
KINSOKU::KINSOKU(){
		m_FullInit = FALSE;
		m_bInitialized = FALSE;
		m_bImplemented = FALSE;
}
//	AvP[VI
KINSOKU::~KINSOKU(){
}


//==============================================================================================================================================
//	ƊJ
//		1t@C1̏ŃRv[g悤ȏꍇ͏CKv܂
//		߂ƂȂĂ Message_printf Lɂ sample.swb sƓ悭Ǝv܂B
//==============================================================================================================================================

//------------------------------------------------------------------
//		XNvgR}h̏
//			(ɕKvȂȂύX̕KvȂ)
//------------------------------------------------------------------
void	KINSOKU::Initialize(char *param,char *namelist){
		int		i,j;
		
		
		if(m_bInitialized == TRUE)	return;
		m_bInitialized = TRUE;	//	ς݃tO
		
		width = 256;
		hight = 1;
		STRING_cpy(crlf,"\r\n");
		
		if(param[0] == '-'){
			i = 1;
			
			while(i < (int)strlen(param)){
				switch(param[i]){
					case '"':
						i++;
						j = 0;
						while(param[i]!='"'){
							if(param[i] == '\\'){
								i++;
								if(param[i] == 'r')			crlf[j++] = 0x0d;
								else if(param[i] == 'n')	crlf[j++] = 0x0a;
								i++;
							}else
								crlf[j++] = param[i++];
							if(j>=5)break;
						}
						i++;
						if(j >= 5){
							Message_error("sR[h܂");
							crlf[4] = 0;
						}else
							crlf[j] = 0;
						break;
					
					case '(':
						i++;
						width = 0;
						while(param[i] != ','){
							width *= 10;
							width += (param[i] - '0');
							i++;
						}
						i++;
						hight = 0;
						while(param[i] != ')'){
							hight *= 10;
							hight += (param[i] - '0');
							i++;
						}
						i++;
						break;
					
					default:
						i++;
				}
				
			}
			
		}
		
		
		if(namelist != NULL && namelist[0] != 0)
			read_namelist(namelist);
		
		
		Message_printf("sR[h:%s  (%d,%d)",crlf,width,hight);
		
		if(m_FullInit == FALSE){
			m_FullInit = TRUE;
			//	ŜʂĈxsȂ
			
			//Message_printf("Ŝ̏");
			
			
		}
		
		//	
		//	P̃ob`ɓXNvgQxw肳ĂȂ炱ɂ͂Qx
		//Message_printf("");
		
		
}

//------------------------------------------------------------------
//		XNvgR}h̏I
//			(ɕKvȂȂύX̕KvȂ)
//------------------------------------------------------------------
void	KINSOKU::Quit( BOOL _bExit )
{
		
		//	ɂ̓XNvggĂȂĂ̂Œ
		
		if(m_bImplemented == FALSE)	return;		//	ϊsĂȂȂA
		m_bImplemented = FALSE;
		m_bInitialized = FALSE;
		
		//	I
		//Message_printf("");
		
		if(et == 1){
			//	̃XNvg݂͑ȂASȏI
			//	P̃ob`ɓXNvgɕʃp[^nĂ̏
			//	ꌋʂoAŜœČʂoꍇȂǂ͂
			
			//Message_printf("I");
			
		}
		
}


//		OXg擾
int		KINSOKU::read_namelist(char *fname){
		char	*mem = NULL;
		int		i,j,len;
		
		
		len = MEM_TargetRead(&mem,fname);
		if(len == 0)	return FALSE;
		
		name_entry = 0;
		i = 0;
		while(i < len){
			if(*(mem+i) == '\t' || *(mem+i) == '\r' || *(mem+i) == '\n'){
				while(*(mem+i) == '\t' && i<len)	i++;
				while(*(mem+i) == '\r' && i<len)	i+=2;
				while(*(mem+i) == '\n' && i<len)	i++;
				continue;
			}
			
			j = 0;
			while(*(mem+i) != '\t' && i<len)	name[name_entry][j++] = *(mem+i++);
			name[name_entry][j] = 0;
			
			while(*(mem+i) == '\t' && i<len)	i++;
			
			j = 0;
			while(*(mem+i) != '-' && i<len){
				j *= 10;
				j += *(mem+i++) - '0';
			}
			if(*(mem+i) == '-' && i<len)	i++;
			nlen_min[name_entry] = j;
			
			j = 0;
			while(*(mem+i) > ' ' && i<len){
				j *= 10;
				j += *(mem+i++) - '0';
			}
			nlen_max[name_entry] = j;
			
			if(++name_entry >= NAME_MAX){
				Message_error("O܂");
				return FALSE;
			}
		}
		
	//	for(i=0 ; i<name_entry ; i++)	_printf("%s %d %d\n",name[i],nlen_min[i],nlen_max[i]);
		
		mem_del(mem);
		
		return TRUE;
}



//==============================================================================================================================================
//	ϊ
//==============================================================================================================================================

#define	KINSOKU_OUTAREA		2	//	ϊ̗eʂ͉Ɍ̔{Ă@eɂĕύXĉ
#define	KINSOKU_RANGE				//	defineLɂƔ͈͌@\LɂȂ

//------------------------------------------------------------------
//	ϊtB^[Tv@@\:ϊ(t@CRs[)
//			ϊȂ out Ɋւ镔͕sv
//------------------------------------------------------------------
int		KINSOKU::Func( CPARAMS cParams ){
		LPCTSTR	sPath;
		LPCTSTR	sParam;
		LPCTSTR	sNameList;
		LPCTSTR	sOutName;
		TCHAR	drive[_MAX_DRIVE],dir[_MAX_DIR],name[_MAX_FNAME],ext[_MAX_EXT],temp[1024/*MAXPATH*/];
		char	*mem=NULL;
		char	*out=NULL;
		int		i,j,ll,len;
		
		sPath     = cParams.GetPath();		///< ^[Qbgt@C (GetFilePath(0)ƂĂ).
		sParam    = cParams.GetString(1);
		sNameList = cParams.GetString(2);
		sOutName  = cParams.GetString(3);
		
		
		Initialize( sParam, sNameList );
		
		len = MEM_TargetRead(&mem,sPath );
		if(len == 0)	return FALSE;		//	t@CȂ
		
		m_bImplemented = TRUE;	//	sς݃tO
		
		//	ϊ̃f[^obt@m
		mem_alloc(char,out, len*KINSOKU_OUTAREA );
		
		
		i = 0;
		#ifdef	KINSOKU_RANGE
		cRange.Init(mem,len);						//͈͌@\Lɂɂ͂̏
		while(cRange.Is(mem,i,len))	i++;		//@XLbvA[XLbv]KvBXLbvKvȊtrueԂ胋[vĂ
		#endif
		
		j = 0;
		while(i < len){
			#ifdef	KINSOKU_RANGE
			while(cRange.Is(mem,i,len))	i++;	//	XLbv
			#endif
			
			while((*(mem+i) == '\t' || *(mem+i) == '\r' || *(mem+i) == '\n') && i<len)	*(out+j++) = *(mem+i++);
			
			if(_ismbblead(*(mem+i)) == 0 && *(mem+i) != '\\' && *(mem+i) != crlf[0]){	//SpłȂ
				while(*(mem+i) != '\n' && i<len)	*(out+j++) = *(mem+i++);
				if(*(mem+i) == '\n')	*(out+j++) = *(mem+i++);
			}else{
				ll=0;
				{
	loop:
					while(*(mem+i) != '\n' && i<len){
						temp[ll++] = (*(mem+i++));
					}
					temp[ll++] = (*(mem+i++));
					if(temp[ll-1] == '\n')	ll--;
					if(temp[ll-1] == '\r')	ll--;
					
					while(*(mem+i) == '\t' && i<len)	i++;
					
					if(_ismbblead(*(mem+i)) != 0 || *(mem+i)=='\\'){	//Sp
						if(crlf[0] == '\r' && crlf[1] == '\n')	{temp[ll++] = '\r';	temp[ll++] = '\n';}
						if(crlf[0] == '\n')						{temp[ll++] = '\n';}
						goto	loop;
					}
				}
				temp[ll] = 0;
				
				
				kinsoku(temp);
			/*	if(STRING_len(temp) > width){
					_printf(temp);
					_printf("\r\n");
				}
			*/	
				STRING_cpy(out+j,temp);
				j += STRING_len(temp);
				STRING_cpy(out+j,"\r\n");
				j += STRING_len("\r\n");
				
			}
			
		}
		
		//	ϊꂽ out ó@@o̓t@C̓ob`ŎwAɎw肳ĂȂΌƓt@C
		
		if( !sOutName )	STRING_cpy(temp,sPath );	//	o̓pXw肳ĂȂÃpX
		else			STRING_cpy(temp,sOutName );	//	o̓pXw肳Ă
		
		FILE_split( temp,drive,dir,name,ext);
		FILE_merge( temp,drive,dir,name,ext);	//ł͕̂܂ܘAAgqς͂
	//	FILE_merge( temp,drive,dir,name,".txt");	//gq".txt"ɕςTv
		
		//	t@Co(݂鎞̓obNAbv쐬)
		file_targetwrite(temp,out,j);
		
		
		//	J
		mem_del(mem);
		mem_del(out);
		
		return TRUE;
}


//		
void	KINSOKU::kinsoku(char *mess){
		char	temp[1024];
		int		i,j,k,top_i,top_j,x,y,gosa,f,renew;
		
		#define	next_line()		{top_i=i;top_j=j;gosa=x=0;y++;}
		
		
		STRING_cpy(temp,mess);
		
		i = j = 0;
		top_i = top_j = 0;
		x = gosa = 0;
		
		renew = 0;
		y = 0;
		while(i < STRING_len(temp)){
			
			//	ɑłĂsR[h͂̂܂܃Rs[(sJEg͂)
			if(string_cmp(temp+i,crlf)==1){
				next_line();
			}else{	//	sR[hɎw肳ĂȂʏs̓XLbv(ʂ͂ɗ܂łɍ폜邪)
				if(*(temp+i) == '\r')	i++;
				if(*(temp+i) == '\n')	i++;
			}
			
			f=0;
			for(k=0 ; k<name_entry ; k++){
				if(string_cmp(temp+i,name[k])==1){
					gosa += (nlen_max[k] - nlen_min[k]);
					
					x += nlen_min[k];
					if(x+gosa >= width){		//	OŉI[o[
						
						//	sLǋL
						renew |= 1;
						STRING_cpy(mess+j,crlf);
						j += STRING_len(crlf);
						next_line();
					}
					
					i += STRING_len(name[k]);
					STRING_cpy(mess+j,name[k]);
					j += STRING_len(name[k]);
					
					f = 1;
				}
			}
			if(f)continue;
			
			if(_ismbblead(*(temp+i)) != 0){	//Sp
				mess[j++] = temp[i++];
				x++;
			}
			mess[j++] = temp[i++];
			x++;
			
			if(x+gosa >= width){				//	I[o[
				
			//		mess[j++] = '\r';	//	s
			//		mess[j++] = '\n';
				if(gosa > 0){	//ϕԂɂ
					
				}
				
				next_line();
				
				if(check_kinsoku(temp+i)){
					Message_printf("\r\n֑\r\n%s",mess);
					
					x += 2;	//vOΏ@V~[g()
					
				}
				
			}
			
		}
		
		
		if(y >= hight)
			Message_printf("sI[o[:%s",mess);
		
		mess[j] = 0;
		
		
		if(renew == 1){
		//	STRING_cat(mess,"\r\n;s");
			Message_printf("\r\nOOŉs\r\n%s",mess);
			
		}
		
}


//		
int		KINSOKU::string_cmp(char *ptr,char *str){
		
		for(int i=0 ; i<STRING_len(str) ; i++){
			if(*(ptr+i) != *(str+i))	return 0;
		}
		
		return 1;
}


//		|C^Ŏw肳Ă镔֑ΏۂȂ TRUE Ԃ
int		KINSOKU::check_kinsoku(char *ptr){
		char	kinsoku_moji[] = "傟ABIHvj[`";
		int		i;
		
		
		if(_ismbblead(*ptr) == 0)	//SpłȂ
			return FALSE;
		
		for(i=0; i<(int)STRING_len(kinsoku_moji) ; i+=2){
			if(
				*(kinsoku_moji+i) == *(ptr) && 
				*(kinsoku_moji+i+1) == *(ptr+1)
			){
				return TRUE;
			}
		}
		
		return FALSE;
}


KINSOKU	*pC_kinsoku = NULL;

