//********************************************************************************************
/**
 * @file		rlsPress.cpp
 * @brief		RLSk
 *
	ƂPȍ\̃TvvO.
 *
	@date		2013/05/14	takedan	VK쐬.
 */
//********************************************************************************************

#define	SW_MODULE_RLSPRESS						///< ̋@\؂藣̓RgAEg.
#ifdef	SW_MODULE_RLSPRESS

#ifndef _STOOLS_H
#include <press/rls.h>
#endif

//********************************************************************************************
/**
 * @class		RLSPRESS
 * @brief		RLSkXNvgR}hNX.
 */
//********************************************************************************************
class RLSPRESS
{
public:
	virtual int		Func( LPCTSTR _sParamString );
	virtual void	Quit( BOOL _bExit ){}
};



//==============================================================================================================================================
//	ϊ
//==============================================================================================================================================

#define	RLSPRESS_OUTAREA		2	//	ϊ̗eʂ͉Ɍ̔{Ă@eɂĕύXĉ

//********************************************************************************************
/**
 * @brief		RLSkϊtB^[Tv@@\:ϊ(t@CRs[)
 *				ϊȂ pOut Ɋւ镔͕sv.
 *
 * @param[in]	LPCTSTR	_sParamString	  ^[Qbgt@C + XNvgŎw肷.
 *
 * @return		int	TRUE: / FALSE:(ftHg)
 */
//********************************************************************************************
int		RLSPRESS::Func( LPCTSTR _sParamString )
{
	CSwbParam	cParam( _sParamString );							///< p[^.
	
	struct StHead
	{
		Char	m_sId[4];
		Char	m_sExt[4];
		Int32	m_iLength;
	};
	
	char	*pMem = NULL;
	char	*pOut = NULL;
	Int32	iSourceLength;
	UInt32	iLength;
	LPCTSTR	szFileName, szOutName;
	StHead	stHead;
	
	
	/// ̎o.
	szFileName = cParam.GetPath();		///< ^[Qbgt@C (GetString(0)ƂĂ).
	szOutName  = cParam.GetOutPath();	///< o̓pX擾(%0͕ϊĂ).
	
	
	/// f[^ǂݍ(֐pMemɗ̈mۂĂ).
	iSourceLength = MEM_TargetRead( &pMem, szFileName );						///< oCi[f[^Ƃăx^ǂ.
	if(iSourceLength == 0)	return FALSE;		///< t@CȂ.
	
	
	/// ϊ̃f[^obt@m	f[^܂ɏꍇ̂ōŒ1KB͊m.
	mem_alloc( char, pOut, ((iSourceLength*RLSPRESS_OUTAREA+1023)/1024)*1024 );
	
	if( 1 > RLS_encodeDWORD( pMem, pOut + sizeof(StHead), &iLength, TRUE, iSourceLength ) )	//!< wb_[Jč쐬.
	{
		Message_error( TEXT("error %s"), szFileName );
	}else{
		Message_printf( TEXT("%s %3d%%"), szFileName, (Int32)((Float32)iLength * 100.f / (Float32)iSourceLength) );
	}
	
	
	/// ϊꂽ pOut ó@@o̓t@C̓ob`ŎwAɎw肳ĂȂΌƓt@C.
	{
		TCHAR	cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_FNAME], cExt[_MAX_EXT], szTemp[_MAX_PATH];
		CTOSJIS	cJis;
		
		FILE_split( szOutName, cDrive, cDir, cName, cExt );
		FILE_merge( szTemp, cDrive, cDir, cName, TEXT(".rls") );	///<gq".txt"ɕςTv.
		
		//! wb_[ǉ.
		stHead.m_sId[0] = 'R';
		stHead.m_sId[1] = 'L';
		stHead.m_sId[2] = 'S';
		stHead.m_sId[3] = 0;
#ifdef _UNICODE
		memcpy( stHead.m_sExt, cJis.From(cExt+(cExt[0]=='.')), 4 );
#endif	// _UNICODE
		stHead.m_iLength = iSourceLength;
		memcpy( pOut, (Char*)&stHead, sizeof(StHead) );
		iLength += sizeof(StHead);
		
		/// t@Co(݂鎞̓obNAbv쐬).
		file_targetwrite( szTemp, pOut, iLength );			///< o.
	}
	
	
	/// J.
	mem_del( pMem );
	mem_del( pOut );
	
	return TRUE;
}


RLSPRESS	*pC_rlsPress = NULL;

#endif	// SW_MODULE_RLSPRESS
