//********************************************************************************************
/**
 * @file		togeGrep.cpp
 * @brief		܂Ƃ߂GREP
 *
 *	̃t@C̏ڍא
 *
 * @date		2010/11/02	hk-taken	VK쐬.
 */
//********************************************************************************************

#define	SW_MODULE_TOGEGREP						///< ̋@\؂藣̓RgAEg.


#ifdef	SW_MODULE_TOGEGREP
//------------------------------------------------------------------
/**
	XNvgR}hNX.
*/
//------------------------------------------------------------------
class TOGEGREP
{
	BOOL		m_bInitialized;
	BOOL		m_bImplemented;
	BOOL		m_bFullInit;
	
	void		Initialize( LPCTSTR _pGrepListName );
	
	TCHAR		m_sGrepList[ 1024 ][ 64 ];
	Int32		m_iEntry;
	
public:
	int			Func( LPCTSTR _sParamString );
	void		Quit( BOOL _bExit );
	
	TOGEGREP();
	~TOGEGREP();
	
};

///	AvP[VN.
TOGEGREP::TOGEGREP()
	: m_bFullInit( FALSE )
	, m_bInitialized( FALSE )
	, m_bImplemented( FALSE )
	, m_iEntry( 0 )
{
	
}
///	AvP[VI.
TOGEGREP::~TOGEGREP(){
}

static const TCHAR	s_sTogeFileExt[] = TEXT(".togeGrep");							///< ꎞt@C̊gq.

//==============================================================================================================================================
/**
	ƊJ.
		1t@C1̏ŃRv[g悤ȏꍇ͏CKv܂
		߂ƂȂĂ Message_printf Lɂ sample.swb sƓ悭Ǝv܂B
*/
//==============================================================================================================================================

//------------------------------------------------------------------
/**
	XNvgR}h̏.
		(ɕKvȂȂύX̕KvȂ)
*/
//------------------------------------------------------------------
void	TOGEGREP::Initialize( LPCTSTR _pGrepListName )
{
	if( m_bInitialized == TRUE )	return;
	m_bInitialized = TRUE;	//	ς݃tO
	
	if( m_bFullInit == FALSE ){
		m_bFullInit = TRUE;
		//	ŜʂĈxsȂ
		TCHAR	*mem = NULL;
		int		iLength = 0;
		
		Message_printf( TEXT("GrepList:%s"), _pGrepListName );
		
		iLength = MEM_TextRead( &mem, _pGrepListName );							///< UNICODȄꍇ UTF16ɕϊēǂ܂܂.
		
		Int32	jj = 0;
		for( Int32 ii=0 ; ii<iLength ; ii++ )
		{
#ifndef _UNICODE
			if( STRING_IsMultiByte( mem + ii ) )
			{
				m_sGrepList[ m_iEntry ][ jj++ ] = *(mem + ii);
				ii++;
			}
			else
#endif
			if( ' ' > *(mem + ii) )
			{
				m_sGrepList[ m_iEntry ][ jj ] = 0;
				if( 0 < STRING_len( m_sGrepList[ m_iEntry ] ) )	m_iEntry++;
				jj = 0;
				continue;
			}
			m_sGrepList[ m_iEntry ][ jj++ ] = *(mem + ii);
		}
		
	//	for( Int32 ii=0 ; ii<m_iEntry ; ii++ )	_printf( TEXT("%d:%s\r\n"), ii, m_sGrepList[ ii ] );
		
		mem_del( mem );
	}
	
	//	
	//	P̃ob`ɓXNvgQxw肳ĂȂ炱ɂ͂Qx
	//Message_printf("");
	
}

//------------------------------------------------------------------
/**
	XNvgR}h̏I.
		(ɕKvȂȂύX̕KvȂ)
*/
//------------------------------------------------------------------
void	TOGEGREP::Quit(BOOL _bExit)
{
	//	ɂ̓XNvggĂȂĂ̂Œ
	
	if( m_bImplemented == FALSE )	return;		///<ϊsĂȂȂA.
	m_bImplemented = FALSE;
	m_bInitialized = FALSE;
	
	///	I.
	//Message_printf("");
	
	if( _bExit == TRUE ){
		//	̃XNvg݂͑ȂASȏI
		//	P̃ob`ɓXNvgɕʃp[^nĂ̏
		//	ꌋʂoAŜœČʂoꍇȂǂ͂
		
		//Message_printf("I");
		
		TCHAR	szName[ 256 ];
#if 0
		const TCHAR	c_sResultFileName[] = TEXT("result.txt");
		FILE_delete( c_sResultFileName );
#endif
		
		/// ꎞt@C}[W.
		for( Int32 iIdx=0 ; iIdx<m_iEntry ; iIdx++ )
		{
			TCHAR	*mem = NULL;
			
			wsprintf( szName, /*256, */TEXT("%d%s%s"), iIdx, m_sGrepList[ iIdx ], s_sTogeFileExt );
			
			Int32	iLength = MEM_TextRead( &mem, szName );							///< UNICODȄꍇ UTF16ɕϊēǂ܂܂.
			
			if( 0 < iLength )
			{
#if 0
				FILE_TextWriteMerge( c_sResultFileName , m_sGrepList[ iIdx ] );
				FILE_TextWriteMerge( c_sResultFileName , TEXT("\r\n") );
				
				FILE_TextWriteMerge( c_sResultFileName , mem );
				
				FILE_TextWriteMerge( c_sResultFileName , TEXT("\r\n") );
#else
				Message_printf( TEXT("%s"), m_sGrepList[ iIdx ] );
				Message_printf( TEXT("%s"), mem );
#endif
			}
			
			mem_del( mem );
			
			FILE_delete( szName );
		}
#if 0
		if( 0 < FILE_GetFileSize( c_sResultFileName ) )
		{
			Message_printf( TEXT("output %s"), c_sResultFileName );
		}else{
			Message_printf( TEXT("no Hit") );
		}
#endif
	}
	
}







//==============================================================================================================================================
//	ϊ
//==============================================================================================================================================

#define	TOGEGREP_OUTAREA		2	///< ϊ̗eʂ͉Ɍ̔{Ă@eɂĕύXĉ.

//********************************************************************************************
/**
 * @brief		܂Ƃ߂GREPϊtB^[Tv@@\:ϊ(t@CRs[)
 *				eLXgf[^舵Tv.
 *				ϊȂ out Ɋւ镔͕sv.
 *
 * @param[in]	LPCTSTR	_sParamString	(e͏)  ^[Qbgt@C + XNvgŎw肷.
 *
 * @return		int	TRUE: / FALSE:(ftHg)
 */
//********************************************************************************************
int		TOGEGREP::Func( LPCTSTR _sParamString )
{
	/// PꋫE.
	const TCHAR	c_sBorderChar[] = TEXT(".,-+/*=;:<>()[] \"\t\r\n\0");
	LPCTSTR		sBorderChar;
	
	CSwbParam	cParam( _sParamString );							///< p[^.
	
	TCHAR	sLineString[ 1024 ];
	TCHAR	szName[ 256 ];
	TCHAR	*mem = NULL;
	LPTSTR	pLineTop = NULL;
	int		ii, iLine, iSourceLength;
	LPCTSTR	szFileName, szGrepListName;
	Bool	bWordSearch = FALSE;
	
	/// ̎o.
	szFileName = cParam.GetPath();								///< ^[Qbgt@C (GetString(0)ƂĂ).
	szGrepListName  = cParam.GetString( 1 );					///< Xgt@C.
	bWordSearch = cParam.GetInt( 2 );							///< PꌟtO.
	
	Initialize( szGrepListName );
	
	
	/// f[^ǂݍ(֐memɗ̈mۂĂ).
	iSourceLength = MEM_TextRead( &mem, szFileName );							///< UNICODȄꍇ UTF16ɕϊēǂ܂܂.
	if(iSourceLength == 0){
		/** G[bZ[W̕\@Message_printfƓAMessage_errorgpƎIȂȂ܂ */
		Message_error( TEXT("file not found:%s"), szFileName );
		return FALSE;						///< t@CȂ.
	}
	
	m_bImplemented = TRUE;					///<	sς݃tOon.
	
	if( bWordSearch )	sBorderChar = c_sBorderChar;
	else				sBorderChar = NULL;
	
	ii = 0;
	iLine = 1;
	pLineTop = (mem + ii);
	
	/// .
	while( ii < iSourceLength )
	{
		LPTSTR	pPtr = mem + ii;
		
		if( *(pPtr) == '\n' )
		{
			iLine++;
			ii++;
			pLineTop = (mem + ii);
			continue;
		}
		
		/// 擪܂͒P̐擪.
		if( sBorderChar == NULL || ( ii==0 || 0 <= STRING_CheckChar( *(pPtr-1), sBorderChar ) ) )
		{
			for( Int32 iIdx=0 ; iIdx<m_iEntry ; iIdx++ )
			{
				if( STRING_buffcmp( pPtr, m_sGrepList[ iIdx ], sBorderChar ) )
				{
					/// s擾.
					Int32	jj = 0;
					while( *(pLineTop + jj) != '\r' && *(pLineTop + jj) != '\n' && jj<1024 )
					{
						sLineString[ jj ] = *(pLineTop + jj);
						jj++;
					}
					sLineString[ jj ] = 0;
					
					wsprintf( szName, /*256, */TEXT("%d%s%s"), iIdx, m_sGrepList[ iIdx ], s_sTogeFileExt );
					FILE_printf( szName, TEXT("%s(%d): %s\r\n"), szFileName, iLine, sLineString );
					
				//	Message_printf( TEXT("Hit:%s"), szFileName );
				}
			}
		}
		
#ifndef	_UNICODE
		if( STRING_IsMultiByte(pPtr) )	ii++;
#endif
		ii++;
		CHECK_LOOPOVER(32000);	///< [vS	Ŏw肵 ii XVȂbreakď~.
	}
	
	
	/// J.
	mem_del(mem);
	
	return TRUE;
}


TOGEGREP	*pC_togeGrep = NULL;

#endif	// SW_MODULE_TOGEGREP
