//********************************************************************************************
/**
 * @file		params.h
 * @brief		p[^ǗNX
	CEzParam  sWritert.
 * 
 * @author		N.Takeda
 * @date		2008/4/18() 14:27:17
 * @date		2011/05/26() 14:27:42	N.Takeda	VɕύX.
 */
//********************************************************************************************

#ifndef	__params_H__	// d`h~
#define	__params_H__	// d`h~}N

//********************************************************************************************
/**
 * @class		CSwbParam
 * @brief		
 * @author		N.Takeda
 * @date		2011/05/31() 11:17:36
 */
//********************************************************************************************
class CSwbParam : public CEzParam
{
private:
	enum{	enExtParamMax = 16	};
	
	
	LPTSTR		m_pExtParam[ enExtParamMax ];	///< ꕶi[obt@. NULLŖgp.
	
	
public:
	//********************************************************************************************
	/**
	 * @brief		^[Qbg̃t@CpX𓾂(t@C܂).
	 * @author		N.Takeda
	 * @date		2011/06/02() 15:54:33
	 *
	 * @return		LPTSTR	
	 */
	//********************************************************************************************
	LPCTSTR	GetPath(){	return GetString( 0 );	}
	
	//********************************************************************************************
	/**
	 * @brief		o̓pX̎擾 (2ȍ~ŏɌIvVłȂt@CpXdlŕԂ).
	 * @author		N.Takeda
	 * @date		2011/06/02() 16:00:38
	 *
	 * @return		LPCTSTR	
	 */
	//********************************************************************************************
	LPCTSTR	GetOutPath()
	{
		Int32	iIdx = 1;								///< 1茟.
		
		while( IsOption( iIdx ) )	iIdx++;
		if( !IsParam( iIdx ) )	return GetString( 0 );
		
		return GetFilePath( iIdx );
	}
	
	//********************************************************************************************
	/**
	 * @brief		FilePath̎擾.
 	 *				CfbNX 0 "̓t@C"Ƃ %n ̓ꕶWJ.
 	 *					%0	t@C(gqȂ)
 	 *					%1	gq܂ރt@C
	 * @author		N.Takeda
	 * @date		2011/05/31() 11:45:54
	 *
	 * @param[in]	cosnt Int32	_iIndex	wt@C̃CfbNX.
	 *
	 * @return		LPCTSTR	|C^.
	 */
	//********************************************************************************************
	LPCTSTR	GetFilePath( const Int32 _iIndex )
	{
		const TCHAR	cSymble = '%';						///< L.
		LPTSTR		pExtParam;
		LPCTSTR		pOrgString;
		TCHAR		cTemp[_MAX_PATH] = TEXT(""), cDir[_MAX_DIR] = TEXT(""), cName[_MAX_FNAME] = TEXT(""), cExt[_MAX_EXT] = TEXT("");
		
		if( !IsParam( _iIndex ) )	return NULL;
		
		/// 0 GetFilePathĂǓԂ̂.
		if( 0 == _iIndex )	return GetString( 0 );
		
		if( NULL != m_pExtParam[ _iIndex ] )	return m_pExtParam[ _iIndex ];	///< ɍ쐬ς.
		
		/// g̈m.
		mem_alloc( TCHAR, m_pExtParam[ _iIndex ], _MAX_PATH );
		pExtParam = m_pExtParam[ _iIndex ];
		
		pOrgString = GetString( _iIndex );	///< ̕.
		if( !pOrgString )	return NULL;
		
		*( pExtParam + 0 ) = '\0';
		
		
		if( (('a' <= *(pOrgString) && *(pOrgString) <= 'z') || ('A' <= *(pOrgString) && *(pOrgString) <= 'Z')) && ':' == *(pOrgString + 1) && '\\' == *(pOrgString + 2) )
		{
			/// wt@CtpXȂwt@C̃pX𕪉.
			FILE_split( pOrgString, cTemp, cDir, NULL, NULL );
		}
		else{
			/// ̓t@C̃pX𕪉.
			FILE_split( GetString( 0 ), cTemp, cDir, NULL, NULL );
		}
		if( *(pOrgString) == '\\' )			///< 擪 \ ͓̎̓pXpȂ.
		{
			FILE_split( pOrgString + 1, NULL, cDir, cName, cExt );
		}else{
			FILE_merge( pExtParam, cTemp, cDir, NULL, NULL );
			FILE_split( pOrgString, NULL, cDir, cName, cExt );
		}
		
		FILE_merge( cTemp, NULL, cDir, cName, cExt );
		if( 0 >= STRING_len( cName ) )
		{
			/// t@C̕ȗĂ鎞A̓t@C̃t@CLǉ.
			STRING_cat( cTemp, TEXT("%1") );
		}
		
		/// ̓t@C̃t@C𕪉.
		FILE_split( GetString( 0 ), NULL, NULL, cName, cExt );
		
		Int32	jj = STRING_len( pExtParam );
		for( Int32 ii=0 ; ii<STRING_len( cTemp ) ; ii++ )
		{
			if( cTemp[ ii ] == '%' )
			{
				ii++;
				*( pExtParam + jj ) = '\0';
				switch( cTemp[ ii ] )
				{
					case '0':
						STRING_cat( pExtParam + jj, cName );
						jj += STRING_len( cName );
						break;
					case '1':
						STRING_cat( pExtParam + jj, cName );
						jj += STRING_len( cName );
						STRING_cat( pExtParam + jj, cExt );
						jj += STRING_len( cExt );
						break;
				}
			}else{
				*( pExtParam + jj++ ) = cTemp[ ii ];
			}
		}
		*( pExtParam + jj ) = '\0';
		
		return pExtParam;
	}
	
	
	//********************************************************************************************
	/**
	 * @brief		wCfbNX̃t@Ĉݎ擾.
 	 *				GetFilePath œꕶWJꂽ̂擾.
	 * @author		N.Takeda
	 * @date		2010/09/03() 23:29:49
	 *
	 * @param[in]	const Int32	_iIdx		ԍ.
	 * @param[in]	LPCTSTR 	_pDefStr	(ȗNULL).
	 *
	 * @return		LPTSTR	
	 */
	//********************************************************************************************
	LPTSTR	GetName( const Int32 _iIdx, LPCTSTR _pDefStr = NULL )
	{
		LPCTSTR		pPtr;
		TCHAR		cName[_MAX_FNAME] = TEXT(""), cExt[_MAX_EXT] = TEXT("");
		
		if( !IsParam( _iIdx ) )	return (LPTSTR)_pDefStr;
		
		pPtr = GetFilePath( _iIdx );
		
		FILE_split( pPtr, NULL, NULL, cName, cExt );
		STRING_cat( cName, cExt, _MAX_FNAME-1 );
		
		return STRING_str( pPtr, cName );
	}
	
	
	//********************************************************************************************
	/**
	 * @brief		RXgN^.
	 * @author		N.Takeda
	 * @date		2011/05/31() 11:31:00
	 */
	//********************************************************************************************
	CSwbParam( LPTSTR _pParamString )
	 : CEzParam( _pParamString )
	{
		memset( m_pExtParam, 0, sizeof(LPTSTR) * enExtParamMax );
	}
	
	//********************************************************************************************
	/**
	 * @brief		RXgN^.
	 * @author		N.Takeda
	 * @date		2011/05/31() 11:31:02
	 */
	//********************************************************************************************
	CSwbParam( LPCTSTR _pParamString )
	 : CEzParam( _pParamString )
	{
		memset( m_pExtParam, 0, sizeof(LPTSTR) * enExtParamMax );
	}
	
	//********************************************************************************************
	/**
	 * @brief		fXgN^.
	 * @author		N.Takeda
	 * @date		2011/05/31() 11:31:05
	 */
	//********************************************************************************************
	virtual ~CSwbParam()
	{
		
		for( Int32 ii=0 ; ii<enExtParamMax ; ii++ )
		{
			mem_del( m_pExtParam[ ii ] );
		}
		
	}
};

#endif // __params_H__ d`h~
