/**************************************************************************//**
    @file       main.h
    @brief      v
    
        ̃t@C̏ڍא
    
    @author     N.Takeda
    @date       2010/11/02() 21:45:46
*//***************************************************************************/

#ifndef ___MAIN__H___   // d`h~
#define ___MAIN__H___   // d`h~}N


#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <string>
#include <list>

#ifdef _STOOLS_H
    #include "stools.h"
#else
    #include <tools.h>
    #include <files/xcopy.h>
    #include <system/ezParam.h>
#endif


using namespace std;


#define WINDOW_TITLE    TEXT("MN MEGA-Mix")   ///< EBhE^Cg
#define APP_NAME        TEXT("swriter.exe")         ///< AvP[V
//#define WINDOW_W      480                         ///< EBhE
//#define WINDOW_H      360                         ///< EBhEc

#define TIMER_LOOP_CONV (WM_USER + 0x00)            ///< ^C}[bZ[W

#define BTN_START       100                         ///< Jn
#define BTN_REFER       101                         ///< Q
#define BTN_FILEUP      102                         ///< XgAbv
#define BTN_FILEDOWN    103                         ///< Xg_E
#define BTN_FILEDEL     104                         ///< Xg폜
#define BTN_DECODE      105                         ///< WJ
#define BTN_PROPERTY    106                         ///< vpeB



/// R}h\.
typedef struct
{
    xstring     sCommand;                               ///< R}h.
    xstring     sParam;                                 ///< p[^.
} SCRIPT_STAT;


/// IvVݒ.
typedef struct
{
    Bool                m_bAuto;                        ///< N.
    Bool                m_bAtExit;                      ///< @N㎩I.
    Bool                m_bOutInfo;                     ///< ʂt@Cɏo.
    Bool                m_bRetexec;                     ///< ^[L[Ŏs.
    
    Bool                m_bBackup;                      ///< obNAbvƂ.
    Int32               m_iRange;                       ///< ͈͌胂[h 0:Ȃ@1:@2:ŵ镨.
    Bool                m_bSearchSubDir;                ///< TufBNg̃t@C邩.
    
    Bool                m_bDefaultCurrent;              ///< false̎Aswbob`t@ĈtH_Jgɂ.
    
    TCHAR               m_sOutInfoName[ _MAX_PATH ];    ///< _CAOɎw肵Ă郁bZ[Wo͐.
    TCHAR               m_sBackupPath[ _MAX_PATH ];     ///< obNAbvt@Co͐.
    
} OPTION_DATA;


typedef std::list< SCRIPT_STAT >    LScriptStat;


//********************************************************************************************
///     O[o\
//********************************************************************************************
struct STRUCT_GLOBAL
{
    /// AvP[V
//  HWND                hMainWnd;                   ///< CEChẼnh.
    HINSTANCE           hInst;                      ///< CX^X.
    TCHAR               MainPath[ _MAX_PATH ];      ///< ƃfBNg.
    HFONT               hFont;                      ///< AvP[VtHg.
    
    UInt32              TimerID;                    ///< ^C}[ID.
    Bool                TimerFlag;                  ///< ^C}[tO.
    Int32               err;
    Int32               old_i, iLimitCnt;
    
    /// qEBhE
    HWND                hStart;
    HWND                hScriptPath;
    HWND                hFileNum;
    HWND                hFlist;
    HWND                hEntry;
    HWND                hInfo;
    
    TCHAR               *m_memMsg;
    
    TCHAR               ScriptPath[ _MAX_PATH ];    ///< 
    TCHAR               MessagePath[ _MAX_PATH ];   ///< bZ[Wo͂pX.
    
    Bool                bFlagStop;                  ///< ̒~tO.
    
    /// ob`R}h
    LScriptStat             m_stScrStat;
    LScriptStat::iterator   m_itStat;
    /// t@CXg
    FILE_XCOPY              m_cXcopy;
    
    
    /// n
    Int32               m_iIdx;                     ///< sCfbNX.
    Int32               autoexec;
    Bool                bLock;                      ///< s1.
    Int32               iErrors;
    
    /// @\ŗp
    Bool                bFuntion_lock;              ///< s1.
    
    /// ݒtO
    OPTION_DATA         m_cSysOption;               ///< VXe(*.ini)̐ݒ.
    OPTION_DATA         m_cBatOption;               ///< ob`t@CŎw肳ꂽݒ.
    OPTION_DATA         *m_pOption;                 ///< ݒ̃|C^. L̂ꂩw.
    
    STRUCT_GLOBAL()
     : m_memMsg( NULL )
     , iErrors( 0 )
     , m_pOption( &m_cSysOption )
    {
        m_cXcopy.Clear();
        m_stScrStat.clear();
    }
};//STRUCT_GLOBAL;


LPCTSTR     pickup_name( LPCTSTR pp );

void        defaultpath( LPTSTR saki, LPCTSTR moto );

Bool        file_targetwrite( LPCTSTR _pFName, char *_pPtr, Int32 _iSize );
Bool        file_textwrite( LPCTSTR _pFName, LPCTSTR _pPtr );


void    Message_error( LPCTSTR format,...);
void    Message_printf( LPCTSTR format,...);
void    Message_win( LPCTSTR str );
void    Message_clear();
void    Message_script();
void    List_clear();


//********************************************************************************************
/**
 * @class       CRANGE_CTRL
 * @brief       ͈͌萧NX
 * @author      N.Takeda
 */
//********************************************************************************************
class CRANGE_CTRL
{
    Bool    m_bMode;            ///< FALSEŋ@\gpȂ
    Bool    m_bSwitch;          ///< w͈͓ۂ̃tO
    
public:
    void    Init( LPCTSTR _mem, Int32 _iLen );
    Bool    Is( LPCTSTR _mem, Int32 ii, Int32 _iLen );
    
    CRANGE_CTRL();
};

/// ͈͌L
#define RANGECHAR_TOP       ''
#define RANGECHAR_BOTTOM    ''


Bool    wchar_cmp( LPCTSTR _pPtr, WCHAR _cCh );

/// OW[s.
BOOL    swriter_ExecModule( LPCTSTR _pCommand, LPCTSTR _sParamString );


extern  STRUCT_GLOBAL   s_stGl;

//#define USE_BOOST                   ///< Lɂꍇ̓rh boost CXg[ĂKv܂B

#endif // ___MAIN__H___ d`h~
