//********************************************************************************************
/**
 * @file		_common.cpp
 * @brief		W@\
	
		@\ include . @\ cppincludeKv͂Ȃ swriterƍ킹.
		\[X𕪂قǂłȂ@\͂ɒu.
 * 
 * @author		N.Takeda
 */
//********************************************************************************************

#define	SW_MODULE_COMMON

//		W@\
int		file_del( LPCTSTR path );
Int32	delete_rem( LPCTSTR _sParamString );
int		filt_excessiveSPACE( LPTSTR ptr, int len );
int		filt_zen2han( LPCTSTR _sParamString );



//	@\Ɋւ郂W[
#include "common\filecopy.cpp"
#include "common\kanji_check.cpp"
#include "common\zen2han.cpp"
#include "common\listsort.cpp"
#include "common\filecheck.cpp"
#include "common\dump.cpp"
#include "common\samesize.cpp"
#include "common\chgrw.cpp"


//̂eNXɓ悤
static	int	msged_copy = 0;
static	int	msged_defrem = 0;


//------------------------------------------------------------------------------
//		I
//------------------------------------------------------------------------------
static	void	common_quit( BOOL _bExit )
{
//		#define		QUIT(class)		if( class != NULL)	class->Quit( _bExit )
	
	msged_copy = 0;
	msged_defrem = 0;
	
	QUIT( pC_filecopy );
	QUIT( pC_listsort );
	QUIT( pC_filecheck );
	QUIT( pC_dump );
	QUIT( pC_kchk );
	QUIT( pC_samesize );
	QUIT( pC_chgrw );
	
}


//------------------------------------------------------------------------------
//		t@C폜
//------------------------------------------------------------------------------
int		file_del( LPCTSTR path )
{
	
	if(path[0] == 0)	return 0;
	
	return FILE_delete( path );
}


//********************************************************************************************
/**
 * @brief		߂폜
 *				("Ŋ镶)̒ߋL͏O܂
 * @author		N.Takeda
 * @date		2011/06/02() 15:47:58
 *
 * @param[in]	LPCTSTR	_sParamString	.
 *
 * @return		Int32	
 */
//********************************************************************************************
Int32	delete_rem( LPCTSTR _sParamString )
{
	CSwbParam	cParam( _sParamString );										///< p[^.
	
	TCHAR		*pMem = NULL;
	LPCTSTR		pLineMark = NULL, pRmStMark = NULL, pRmEdMark = NULL;
	Int32		iFSize;
	LPCTSTR		sPath;
	LPCTSTR		sOutPath;
	
	sPath    = cParam.GetPath();												///< ^[Qbgt@C.
	sOutPath = cParam.GetOutPath();
	
	iFSize = MEM_TextRead( &pMem, sPath );
	if( 0 >= iFSize )
	{
		Message_error( TEXT("not found.%s"), pickup_name( sPath ) );
		return 0;
	}
	
	/// w肳ĂȂ̓ftHgł͂Ȃ 󕶎ɂȂ.
	pLineMark = cParam.GetStringOption( 'L', TEXT("//") );
	pRmStMark = cParam.GetStringOption( 'S', TEXT("/*") );
	pRmEdMark = cParam.GetStringOption( 'E', TEXT("*/") );
	
	iFSize = FILT_deleteREM( pMem, iFSize, pLineMark, pRmStMark, pRmEdMark, '\"' );	///< sߋL,͈͒ߋLn_,͈͒ߋLI_,ƂL.
	iFSize = FILT_excessiveSPACE( pMem, iFSize );
	
	/// ϊꂽ out ó@@o̓t@C̓ob`ŎwAɎw肳ĂȂΌƓt@C.
	iFSize = file_textwrite( sOutPath, pMem );
	
	mem_del( pMem );
	
	return iFSize;
}


//------------------------------------------------------------------------------
//		Sp𔼊p
//------------------------------------------------------------------------------
int		filt_zen2han( LPCTSTR _sParamString )
{
	CSwbParam	cParam( _sParamString );							///< p[^.
	
	TCHAR		*pMem = NULL;
	int			iLen, olen;
	xstring		sPath;
	xstring		sOutPath;
	
	
	sPath     = cParam.GetPath();		///< ^[Qbgt@C.
	sOutPath  = cParam.GetOutPath();	///< 1t@CpXƂĎ擾(%0ϊē).
	
	iLen = MEM_TextRead( &pMem, sPath.c_str() );
	if( iLen == 0 ){
		Message_error( TEXT("zen2han  failed. %s"), sPath.c_str() );
		return 0;
	}
	
	olen = FILT_zen2han( (u_char*)pMem, iLen );
	
	if( sOutPath.empty()  )
		file_textwrite( sPath.c_str(), pMem );
	else
		file_textwrite( sOutPath.c_str(), pMem );
	
	mem_del( pMem );
	
	Message_printf( TEXT("zen2han %s %dKb->%dKb"), cParam.GetName( 0 ), (iLen+1023)/1024, (olen+1023)/1024 );
	
	return 1;
}
