//==============================================================================
//		
//==============================================================================
#include "../../main.h"
#include <mbstring.h>


//==================================================
//		
//==================================================
static BOOL	KNJ_CheckKnjCode( unsigned short code )
{
	int		i;
	
	static unsigned short	check[] = {
		'','','','','','','','','','',
		'','','','','','','','','','',
		'','','','','','','','','','',
		'','','','','','','','',
		'','','','','','','','',
		'','','','','','','','','',		//''ɑΉVOoCg͂Ȃ
		'`','a','b','c','d','e','f','g','h','i','j','k','l',
		'm','n','o','p','q','r','s','t','u','v','w','x','y',
		'','','','','','','','','','','','','',
		'','','','','','','','','','','','','',
		'u','v','B','A','[','@','H','I','i','j','m','n','`','E','',
		'O','P','Q','R','S','T','U','V','W','X','{','|','','^',
		0x0000 };
	
	for( i=0;check[i]!=0x0000;i++){
		if( code == check[i] )	return	TRUE;
	}
	return	FALSE;
}


//==================================================
//		_uoCgTRUEԂ
//==================================================
static BOOL	KNJ_searchDouble( BYTE Hi,BYTE Lo )
{
	unsigned short	code;
	char			str[] = {0x5B,0x00,0x00,0x5D,0x00};
	
	
	if(	_ismbblead(Hi) == 0 ||		// }`oCg1oCgځH
		_ismbbtrail(Lo) == 0 )		// }`oCg2oCgځH
			return FALSE;
	
	code = Hi * 0x0100 + Lo;
	
	if( _ismbclegal(code) != 0 ){
		if( 0x8140 <= code && code <= 0x9872 )	return TRUE;
		if( 0x9890 <= code && code <= 0xEAA4 )	return TRUE;
		if( 0xED40 <= code && code <= 0xEEFB )	return TRUE;
		if( 0xFA40 <= code && code <= 0xFC4B )	return TRUE;
		return	TRUE;
	}
	
	return	FALSE;
}


//		Sp𔼊pɕϊ
DWORD	FILT_zen2han( u_char *ptr, DWORD length )
{
	DWORD			len;
	unsigned short	code,conv_code;
	int				i;
	
	
	len = 0;
	while(1){
		if( len >= length )	break;
		
		if( KNJ_searchDouble( *(ptr + len),*(ptr + len + 1) ) == TRUE ){
			code = *(ptr + len) * 0x0100 + *(ptr + len + 1);
			
			if( i = KNJ_CheckKnjCode( code ) == TRUE ){
				
				if( HIBYTE(code) == 0x81 && LOBYTE(code) == 0x60  ){			// `͓
					*(ptr + len) = '~';
					
					// 2oCg1oCg
					BUF_move( (char*)(ptr + len + 2),(char*)(ptr + len + 1),length - len - 2 );	///< unicodeɖΉ
					length -= 1;
				}
				else{
					conv_code = _mbctombb( code );
					if( conv_code != code ){
						*(ptr + len) = LOBYTE(conv_code);
						
						// 2oCg1oCg
						BUF_move( (char*)(ptr + len + 2),(char*)(ptr + len + 1),length - len - 2 );
						length -= 1;
					}
				}
			}
			else{
				len++;	// ݂̕QoCĝ
			}
		}
		len++;
	}
	
	return	length;
}
