//********************************************************************************************
/**
 * @file		smpl_d2arc.cpp
 * @brief		D2A[JCo
 *
 *	̃t@C̏ڍא
 *
 * @date		2013/01/09	takedan	VK쐬.
 */
//********************************************************************************************

//#define	SW_MODULE_SMPL_D2ARC						///< ̋@\؂藣̓RgAEg.
#if 0//def	SW_MODULE_SMPL_D2ARC

#ifdef _UNICODE

//********************************************************************************************
/**
 * @class		SMPL_D2ARC
 * @brief		D2A[JCoXNvgR}hNX.
 */
//********************************************************************************************
class SMPL_D2ARC
{
	Bool		m_bInitialized;
	Bool		m_bImplemented;
	Bool		m_bFullInit;
	
	void		Initialize();
	
	Char		*m_pOut;
	Int32		m_iLength;
	TCHAR		m_sOutName[ T_MAXPATH ];
	
	enum{	enBuffSize = 1024*1024	};
	
	struct StFIleInfo
	{
		UInt32	m_uCrcName;
		UInt32	m_uOffset;
		UInt32	m_uSize;
	};
	struct StHeader
	{
		Char		m_sId[ 4 ];
		Int16		m_iEntry;
		Int16		m_iRefEntry;
		
		StFIleInfo	m_stFiles[ 256 ];	//!< ől. 256̃f[^킯ł͂Ȃ.
	};
	
	StHeader	m_stHeader;
	
public:
	virtual int		Func( LPCTSTR _sParamString );
	virtual void	Quit( Bool _bExit );
	
	SMPL_D2ARC();
	virtual ~SMPL_D2ARC();
	
};

//********************************************************************************************
/**
 * @brief		D2A[JCoRXgN^.
 */
//********************************************************************************************
SMPL_D2ARC::SMPL_D2ARC()
	: m_bFullInit( FALSE )
	, m_pOut( NULL )
	, m_sOutName()
	, m_bInitialized( FALSE )
	, m_bImplemented( FALSE )
{
	
}

//********************************************************************************************
/**
 * @brief		D2A[JCofXgN^.
 */
//********************************************************************************************
SMPL_D2ARC::~SMPL_D2ARC()
{
	
}


//==============================================================================================================================================
/**
	ƊJ.
		1t@C1̏ŃRv[g悤ȏꍇ͏CKv܂
		߂ƂȂĂ Message_printf Lɂ sample.swb sƓ悭Ǝv܂B
*/
//==============================================================================================================================================

//********************************************************************************************
/**
 * @brief		D2A[JCoXNvgR}h̏.
 *				(ɕKvȂȂύX̕KvȂ)
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	SMPL_D2ARC::Initialize()
{
	if( m_bInitialized == TRUE )	return;
	m_bInitialized = TRUE;	//	ς݃tO
	
	if( m_bFullInit == FALSE )
	{
		m_bFullInit = TRUE;
		//	ŜʂĈxsȂ
		
		//Message_printf( TEXT("Ŝ̏") );
		
		/// ϊ̃f[^obt@m
		mem_alloc( Char, m_pOut, enBuffSize );
		m_iLength = 0;
		
		memcpy( m_stHeader.m_sId, "D2C", 4 );
		m_stHeader.m_iEntry = 0;
		m_stHeader.m_iRefEntry = 0;
		
	}
	
	//	
	//	P̃ob`ɓXNvgQxw肳ĂȂ炱ɂ͂Qx
	//Message_printf( TEXT("") );
	
}

//********************************************************************************************
/**
 * @brief		D2A[JCoXNvgR}h̏I.
 *				(ɕKvȂȂύX̕KvȂ)
 *
 * @param[in]	Bool	_bExit	.
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	SMPL_D2ARC::Quit(Bool _bExit)
{
	//	ɂ̓XNvggĂȂĂ̂Œ
	
	if( m_bImplemented == FALSE )	return;		///<ϊsĂȂȂA.
	m_bImplemented = FALSE;
	m_bInitialized = FALSE;
	
	///	I.
	//Message_printf( TEXT("I") );
	
	if( _bExit == TRUE )
	{
		//	̃XNvg݂͑ȂASȏI
		//	P̃ob`ɓXNvgɕʃp[^nĂ̏
		//	ꌋʂoAŜœČʂoꍇȂǂ͂
		#define	HEADER_SIZE		(8)
		
	//	Message_printf( TEXT("Ŝ̏I") );
		
		Char	cRefStr[1024] = "";
		Int32	iRefLength = 0;
		{
			TCHAR	cWork[T_MAXPATH], cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_PATH];
			FILE_split( m_sOutName, cDrive, cDir, cName, NULL );
			FILE_merge( cWork, cDrive, cDir, cName, TEXT(".d2a") );
			
			TCHAR	*pMem = NULL;
			Int32	iLen = MEM_TextRead( &pMem, cWork );
			
			TCHAR	*pp = pMem;
			while( 1 )
			{
				pp = STRING_str( pp, TEXT("<Reference") );
				if( !pp )	break;
				pp = STRING_str( pp, TEXT("<data name=\"") );
				if( !pp )	break;
				pp += STRING_len( TEXT("<data name=\"") );
				Int32	ii=0;
				while( *pp != '"' )	cWork[ ii++ ] = *pp++;
				cWork[ ii ] = '\0';
				
				if( STRING_cmp( cWork, TEXT("n_all") ) == 0 )	continue;
				
				if( cWork[ 0 ] != '@' )	continue;
				TCHAR	*pPtr = &cWork[ 1 ];
				
				CTOSJIS	cJis(pPtr);
				BUF_copy( &cRefStr[ iRefLength ], cJis.Get(), STRING_len(pPtr) );
				iRefLength += STRING_len( pPtr ) + 1;
				m_stHeader.m_iRefEntry++;
			}
			
			del_alloc( pMem );
		}
		if(0<iRefLength)	iRefLength += 4 - (iRefLength % 4);
		
		//! eItZbgɃwb_[Z.
		for( Int32 ii=0 ; ii<m_stHeader.m_iEntry ; ii++ )
		{
			m_stHeader.m_stFiles[ ii ].m_uOffset += (HEADER_SIZE + sizeof(StFIleInfo)*m_stHeader.m_iEntry) + iRefLength;
		}
		
		//! f[^o.
		FILE_TargetWrite( m_sOutName, &m_stHeader, HEADER_SIZE + sizeof(StFIleInfo)*m_stHeader.m_iEntry );
		if(0<iRefLength)	FILE_TargetWriteMerge( m_sOutName, cRefStr, iRefLength );
		FILE_TargetWriteMerge( m_sOutName, m_pOut, m_iLength );
		
		del_alloc( m_pOut );
		#undef	HEADER_SIZE
	}
	
}







//==============================================================================================================================================
//	ϊ
//==============================================================================================================================================

#define	SMPL_D2ARC_OUTAREA		2	///< ϊ̗eʂ͉Ɍ̔{Ă@eɂĕύXĉ.
#define	SMPL_D2ARC_RANGE				///< defineLɂƔ͈͌@\LɂȂ.


//********************************************************************************************
/**
 * @brief	D2A[JCoϊtB^[Tv@@\:ϊ
 *			eLXgf[^舵Tv.
 *			֐ patol.lib gpTvɂȂĂ邪Ag͊SɕʕɕςĂ肠܂.
 *
 *			
 *
 * @param[in]	LPCTSTR	_sParamString	  ^[Qbgt@C + XNvgŎw肷.
 *
 * @return		int	TRUE: / FALSE:(ftHg)
 */
//********************************************************************************************
int		SMPL_D2ARC::Func( LPCTSTR _sParamString )
{
	CSwbParam	cParam( _sParamString );							///< p[^.
	
	Char		*pMem = NULL;
	int			iSourceLength;
	LPCTSTR		szFileName;
	Char		cCrcName[ _MAX_FNAME ];
	
	/// ̎o.
	/**
	 * ^[Qbgt@C (GetString(0)ƂĂ).
	 * swb t@Cł͎w肵ȂAVXeŕt.
	 */
	szFileName = cParam.GetPath();
	
	
	/// @\̏.
	Initialize();
	
	{
		TCHAR	cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_PATH], cExt[_MAX_EXT];
		FILE_split( szFileName, cDrive, cDir, cName, cExt );
		
		if( STRING_cmp( cExt, TEXT(".d2a") ) == 0 || STRING_cmp( cExt, TEXT(".d2b") ) == 0 )
		{
			FILE_merge( m_sOutName, cDrive, cDir, cName, TEXT(".d2c") );
			STRING_cpy( cName, TEXT("D2DATA") );
		}else{
			STRING_cat( cName, TEXT(".tga") );
		}
		
		CTOSJIS	cJis(cName);
		memcpy( cCrcName, cJis.Get(), strlen(cJis.Get())+1 );
	}
	
	
	
	/// f[^ǂݍ(֐pMemɗ̈mۂĂ).
	iSourceLength = MEM_TargetRead( &pMem, szFileName );							///< UNICODȄꍇ UTF16ɕϊēǂ܂܂.
	if( iSourceLength == 0 )
	{
		/** G[bZ[W̕\@Message_printfƓAMessage_errorgpƎIȂȂ܂ */
		Message_error( TEXT("file not found:%s"), szFileName );
		return FALSE;						///< t@CȂ.
	}
	
	m_bImplemented = TRUE;					///< sς݃tOon. onɂȂQuit()sȂ.
	
	T_ASSERT( m_iLength+iSourceLength < enBuffSize );
	if( m_iLength+iSourceLength >= enBuffSize )
	{
		Message_error( TEXT("buff over:%s"), szFileName );
		return FALSE;
	}
	BUF_copy( m_pOut + m_iLength, pMem, iSourceLength );
	
	CTOUTF16	cUtf(cCrcName);
	m_stHeader.m_stFiles[ m_stHeader.m_iEntry ].m_uCrcName = STRING_crc32( cUtf.Get() );
	m_stHeader.m_stFiles[ m_stHeader.m_iEntry ].m_uOffset = m_iLength;
	m_stHeader.m_stFiles[ m_stHeader.m_iEntry ].m_uSize = iSourceLength;
	Message_printf( TEXT("%-24s 0x%08X,0x%08X,0x%08X"), cUtf.Get(), m_stHeader.m_stFiles[ m_stHeader.m_iEntry ].m_uCrcName, m_stHeader.m_stFiles[ m_stHeader.m_iEntry ].m_uOffset, m_stHeader.m_stFiles[ m_stHeader.m_iEntry ].m_uSize );
	m_stHeader.m_iEntry++;
	
	
	m_iLength += ((iSourceLength+3)/4)*4;
	
	/// J.
	del_alloc( pMem );
	
	return TRUE;
}
#else
class SMPL_D2ARC
{
public:
	virtual int		Func( LPCTSTR _sParamString ){return 0;}
	virtual void	Quit( BOOL _bExit ){}
	
	SMPL_D2ARC(){}
	virtual ~SMPL_D2ARC(){}
};
#endif	// _UNICODE


SMPL_D2ARC	*pC_smpl_d2arc = NULL;

#endif	// SW_MODULE_SMPL_D2ARC
