//********************************************************************************************
/**
 * @file		smpl_d2pack.cpp
 * @brief		D2CpbNf[^쐬
 *
 *	̃t@C̏ڍא
 *
 * @date		2013/03/19	takedan	VK쐬.
 */
//********************************************************************************************

#define	SW_MODULE_SMPL_D2PACK						///< ̋@\؂藣̓RgAEg.
#ifdef	SW_MODULE_SMPL_D2PACK

#ifdef _UNICODE

#ifndef _STOOLS_H
#include <system/win32/env.h>
#endif

//********************************************************************************************
/**
 * @class		SMPL_D2PACK
 * @brief		D2CpbNf[^쐬XNvgR}hNX.
 */
//********************************************************************************************
class SMPL_D2PACK
{
	BOOL		m_bInitialized;
	BOOL		m_bImplemented;
	BOOL		m_bFullInit;
	
	void		Initialize();
	
	enum{	enBuffSize = 1024*1024	};
	
	struct StFIleInfo
	{
		UInt32	m_uCrcName;
		UInt32	m_uOffset;
		UInt32	m_uSize;
	};
	enum{	HEADER_SIZE = (8)	};		//!< StHeader  m_stFiles TCY.
	struct StHeader
	{
		Char		m_sId[ 4 ];
		Int16		m_iEntry;
		Int16		m_iRefEntry;
		
		StFIleInfo	m_stFiles[ 256 ];	//!< ől. 256̃f[^킯ł͂Ȃ.
	};
	
	struct StPacFile
	{
		TCHAR		m_sPath[ T_MAXPATH ];
		Char		m_sTexName[ T_MAXNAME ];
		Int32		m_iSize;
	};
	
public:
	virtual int		Func( LPCTSTR _sParamString );
	virtual void	Quit( BOOL _bExit );
	
	SMPL_D2PACK();
	virtual ~SMPL_D2PACK();
	
};

//********************************************************************************************
/**
 * @brief		D2CpbNf[^쐬RXgN^.
 */
//********************************************************************************************
SMPL_D2PACK::SMPL_D2PACK()
	: m_bFullInit( FALSE )
	, m_bInitialized( FALSE )
	, m_bImplemented( FALSE )
{
	
}

//********************************************************************************************
/**
 * @brief		D2CpbNf[^쐬fXgN^.
 */
//********************************************************************************************
SMPL_D2PACK::~SMPL_D2PACK()
{
	
}


//==============================================================================================================================================
/**
	ƊJ.
		1t@C1̏ŃRv[g悤ȏꍇ͏CKv܂
		߂ƂȂĂ Message_printf Lɂ sample.swb sƓ悭Ǝv܂B
*/
//==============================================================================================================================================

//********************************************************************************************
/**
 * @brief		D2CpbNf[^쐬XNvgR}h̏.
 *				(ɕKvȂȂύX̕KvȂ)
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	SMPL_D2PACK::Initialize()
{
	if( m_bInitialized == TRUE )	return;
	m_bInitialized = TRUE;	//	ς݃tO
	
	if( m_bFullInit == FALSE )
	{
		m_bFullInit = TRUE;
		//	ŜʂĈxsȂ
		
		//Message_printf( TEXT("Ŝ̏") );
		
	}
	
	//	
	//	P̃ob`ɓXNvgQxw肳ĂȂ炱ɂ͂Qx
	//Message_printf( TEXT("") );
	
}

//********************************************************************************************
/**
 * @brief		D2CpbNf[^쐬XNvgR}h̏I.
 *				(ɕKvȂȂύX̕KvȂ)
 *
 * @param[in]	BOOL	_bExit	.
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	SMPL_D2PACK::Quit(BOOL _bExit)
{
	//	ɂ̓XNvggĂȂĂ̂Œ
	
	if( m_bImplemented == FALSE )	return;		///<ϊsĂȂȂA.
	m_bImplemented = FALSE;
	m_bInitialized = FALSE;
	
	///	I.
	//Message_printf( TEXT("I") );
	
	if( _bExit == TRUE )
	{
		//	̃XNvg݂͑ȂASȏI
		//	P̃ob`ɓXNvgɕʃp[^nĂ̏
		//	ꌋʂoAŜœČʂoꍇȂǂ͂
		
		//Message_printf( TEXT("Ŝ̏I") );
	}
	
}







//==============================================================================================================================================
//	ϊ
//==============================================================================================================================================

#define	SMPL_D2PACK_OUTAREA		2	///< ϊ̗eʂ͉Ɍ̔{Ă@eɂĕύXĉ.

//********************************************************************************************
/**
 * @brief	D2CpbNf[^쐬ϊtB^[Tv@@\:ϊ
 *			eLXgf[^舵Tv.
 *			֐ patol.lib gpTvɂȂĂ邪Ag͊SɕʕɕςĂ肠܂.
 *
 *			
 *
 * @param[in]	LPCTSTR	_sParamString	  ^[Qbgt@C + XNvgŎw肷.
 *
 * @return		int	TRUE: / FALSE:(ftHg)
 */
//********************************************************************************************
int		SMPL_D2PACK::Func( LPCTSTR _sParamString )
{
	CSwbParam	cParam( _sParamString );							///< p[^.
	
	TCHAR		cDrive[_MAX_DRIVE], cDir[_MAX_DIR], cName[_MAX_PATH], cExt[_MAX_EXT], cListName[T_MAXPATH];
	TCHAR		cWork[ 256 ];
	TCHAR		*pMem = NULL;
	Char		*pOut = NULL;
	int			ii, iOffset, iSourceLength;
	LPCTSTR		szFileName, szOutName;
	StHeader	*pHeader;
	StPacFile	stPacFiles[ 256 ];
	Int32		iPacEntry = 0;
	Char		cRefStr[1024] = "";
	Int32		iRefLength = 0;
	
	
	szFileName = cParam.GetPath();
	szOutName  = cParam.GetOutPath();
	
	
	/// @\̏.
	Initialize();
	
	/// f[^ǂݍ(֐pMemɗ̈mۂĂ).
	iSourceLength = MEM_TextRead( &pMem, szFileName );							///< UNICODȄꍇ UTF16ɕϊēǂ܂܂.
	if( iSourceLength == 0 )
	{
		/** G[bZ[W̕\@Message_printfƓAMessage_errorgpƎIȂȂ܂ */
		Message_error( TEXT("file not found:%s"), szFileName );
		return FALSE;						///< t@CȂ.
	}
	
	m_bImplemented = TRUE;					///< sς݃tOon. onɂȂQuit()sȂ.
	
	/// ϊ̃f[^obt@m	f[^܂ɏꍇ̂ōŒ1KB͊m.
	mem_alloc( Char, pOut, enBuffSize );
	
	pHeader = (StHeader*)pOut;
	
	
	//! wb_[Zbg.
	memcpy( pHeader->m_sId, "D2C", 4 );
	pHeader->m_iEntry = 0;
	pHeader->m_iRefEntry = 0;
	
	
	{
		//! pbNt@C.
		TCHAR	*pp = pMem;
		
		Message_printf( TEXT("\r\n%s(%d)"), szFileName, stPacFiles[ iPacEntry ].m_iSize );
		{
			CTOSJIS	cJis( TEXT("D2DATA") );
			memcpy( stPacFiles[ iPacEntry ].m_sTexName, cJis.Get(), strlen(cJis.Get())+1 );
			
			FILE_split( szFileName, NULL, NULL, cName, cExt );
			FILE_split( szFileName, cDrive, cDir, NULL, NULL );
			
			FILE_merge( cListName, cDrive, cDir, cName, TEXT(".txt") );
			
			FILE_merge( stPacFiles[ iPacEntry ].m_sPath, cDrive, cDir, cName, TEXT(".d2b") );
			stPacFiles[ iPacEntry ].m_iSize = FILE_GetFileSize( stPacFiles[ iPacEntry ].m_sPath );
			
			if( stPacFiles[ iPacEntry ].m_iSize == 0 )
			{
				Message_error( TEXT("not found:%s"), stPacFiles[ iPacEntry ].m_sPath );
				return FALSE;
			}
		//	Message_printf( TEXT("%s(%d)"), stPacFiles[ iPacEntry ].m_sTexName, stPacFiles[ iPacEntry ].m_iSize );
			iPacEntry++;
		}
		
		while( 1 )
		{
			pp = STRING_str( pp, TEXT("<tex_param") );
			if( !pp )	break;
			pp = STRING_str( pp, TEXT("fname=\"") );
			if( !pp )	break;
			pp += STRING_len( TEXT("fname=\"") );
			ii = 0;
			while( *pp != '"' )	cWork[ ii++ ] = *pp++;
			cWork[ ii ] = '\0';
			
			for( ii=0 ; ii<iPacEntry ; ii++ )
			{
				CTOUTF16	cUtf( stPacFiles[ ii ].m_sTexName );
				if( 0 == STRING_cmp( cUtf.Get(), cWork ) )	break;
			}
			
			if( ii >= iPacEntry )
			{
				FILE_printf( cListName, TEXT("%s\r\n"), cWork );
				
			//	STRING_cpy( stPacFiles[ iPacEntry ].m_sTexName, cWork );
				CTOSJIS	cJis(cWork);
				memcpy( stPacFiles[ iPacEntry ].m_sTexName, cJis.Get(), strlen(cJis.Get())+1 );
				
				FILE_split( cWork, NULL, NULL, cName, cExt );
				FILE_split( szFileName, cDrive, cDir, NULL, NULL );
				
				FILE_merge( stPacFiles[ iPacEntry ].m_sPath, cDrive, cDir, cName, TEXT(".gim") );
				if( FILE_GetFileSize( stPacFiles[ iPacEntry ].m_sPath ) == 0 )
				{
					catyen( cDir );
					STRING_cat( cDir, TEXT("gim") );
					FILE_merge( stPacFiles[ iPacEntry ].m_sPath, cDrive, cDir, cName, TEXT(".gim") );
				}
				stPacFiles[ iPacEntry ].m_iSize = FILE_GetFileSize( stPacFiles[ iPacEntry ].m_sPath );
				if( 0 == stPacFiles[ iPacEntry ].m_iSize )
				{
					Message_error( TEXT("not found:%s"), stPacFiles[ iPacEntry ].m_sPath );
				}
			//	Message_printf( TEXT("%s(%d)"), stPacFiles[ iPacEntry ].m_sTexName, stPacFiles[ iPacEntry ].m_iSize );
				iPacEntry++;
			}
		}
	}
	{
		//! t@X.
		TCHAR	*pp = pMem;
		while( 1 )
		{
			pp = STRING_str( pp, TEXT("<Reference") );
			if( !pp )	break;
			pp = STRING_str( pp, TEXT("<data name=\"") );
			if( !pp )	break;
			pp += STRING_len( TEXT("<data name=\"") );
			ii = 0;
			while( *pp != '"' )	cWork[ ii++ ] = *pp++;
			cWork[ ii ] = '\0';
			
		//	if( STRING_cmp( cWork, TEXT("n_all") ) == 0 )	continue;
			if( cWork[ 0 ] != '@' )	continue;
			TCHAR	*pPtr = &cWork[ 1 ];
			
			CTOSJIS	cJis(pPtr);
			BUF_copy( &cRefStr[ iRefLength ], cJis.Get(), STRING_len(pPtr) );
			iRefLength += STRING_len( pPtr ) + 1;
			pHeader->m_iRefEntry++;
		}
		if(0<iRefLength)	iRefLength += 4 - (iRefLength % 4);
	}
	
	iOffset = (HEADER_SIZE + sizeof(StFIleInfo) * iPacEntry) + iRefLength;
	for( ii=0 ; ii<iPacEntry ; ii++ )
	{
		CTOUTF16	cUtf( stPacFiles[ ii ].m_sTexName );
		pHeader->m_stFiles[ ii ].m_uCrcName = STRING_crc32( cUtf.Get() );
		pHeader->m_stFiles[ ii ].m_uOffset = iOffset;
		pHeader->m_stFiles[ ii ].m_uSize = stPacFiles[ ii ].m_iSize;
		Message_printf( TEXT("%-24s 0x%08X,0x%08X,0x%08X"), cUtf.Get(), pHeader->m_stFiles[ ii ].m_uCrcName, pHeader->m_stFiles[ ii ].m_uOffset, pHeader->m_stFiles[ ii ].m_uSize );
		
		iOffset += ((stPacFiles[ ii ].m_iSize + 3)/4)*4;
	}
	
	pHeader->m_iEntry = iPacEntry;
	//! t@XRs[.
	if(0<iRefLength)	BUF_copy( pOut + HEADER_SIZE + sizeof(StFIleInfo)*iPacEntry, cRefStr, iRefLength );
	
	iOffset = (HEADER_SIZE + sizeof(StFIleInfo) * iPacEntry) + iRefLength;
	for( ii=0 ; ii<iPacEntry ; ii++ )
	{
		Char	*pTex = NULL;
		Int32	iLength = MEM_TargetRead( &pTex, stPacFiles[ ii ].m_sPath );
		
		if( iOffset+iLength >= enBuffSize )
		{
			del_alloc( pTex );
			del_alloc( pMem );
			del_alloc( pOut );
			Message_error( TEXT("buff over:%s"), stPacFiles[ ii ].m_sPath );
			return FALSE;
		}
		
		BUF_copy( pOut + iOffset, pTex, iLength );
		iOffset += ((iLength + 3)/4)*4;
		del_alloc( pTex );
	}
	
	
	/// ϊꂽ pOut(iOffset) ó@@o̓t@C̓ob`ŎwAɎw肳ĂȂΌƓt@C.
	{
		TCHAR	cTemp[ T_MAXPATH ], szTemp[ T_MAXPATH ];
		TCHAR	cFolder[][16] = {
			TEXT("scene"),
			TEXT("play"),
			TEXT("ui"),
		};
		Int32	iFolderIndex = 0;
		
		FILE_GetCurrentDirectory( cTemp, T_MAXPATH );
		//if( STRING_str( cTemp, TEXT("play") ) != NULL )		iFolderIndex = 1;
		//else if( STRING_str( cTemp, TEXT("ui") ) != NULL )	iFolderIndex = 2;
		
		FILE_split( szOutName, NULL, NULL, cName, NULL );
	//	ENV_GetStr( cTemp, T_MAXPATH, TEXT("ROCK_ROOT") );
	//	STRING_printf( szTemp, T_MAXPATH, TEXT("%s\\discRoot\\psp\\%s\\graphics\\%s.d2c"), cTemp, cFolder[ iFolderIndex ], cName );
	
	//	STRING_printf( szTemp, T_MAXPATH, TEXT("%s\\resource\\psp\\%s\\graphics\\d2c\\%s.d2c"), cTemp, cFolder[ iFolderIndex ], cName );
		
		// 2013/7/8 C abe shunta.
		STRING_printf( szTemp, T_MAXPATH, TEXT("%s\\d2c\\%s.d2c"), cTemp, cName );

		FILE_TargetWrite( szTemp, pOut, iOffset );
	}
	
	
	/// J.
	del_alloc( pMem );
	del_alloc( pOut );
	
	return TRUE;
}
#else
class SMPL_D2PACK
{
public:
	virtual int		Func( LPCTSTR _sParamString ){return 0;}
	virtual void	Quit( BOOL _bExit ){}
	
	SMPL_D2PACK(){}
	virtual ~SMPL_D2PACK(){}
};
#endif	// _UNICODE


SMPL_D2PACK	*pC_smpl_d2pack = NULL;

#endif	// SW_MODULE_SMPL_D2PACK
